//<!--
/*
Program name: The 5th generation Javascript paginator for ePub Reader (without annotation)
Last update:  2011/07/24 17:24 by Hao-Tung Lin
*/

//~~~~~~~以下參數務必設定~~~~~~~~~~~~~
var inWhichPlatform = 1;		//0:開發, 1:Android, 2:iPad, 3:PC
var iPadBaseURL = "http://localhost/MyCGI?msg=";		//iPad需設定此參數
var paddingLeft = 40;			//左邊界
var paddingRight = 40;			//右邊界
var paddingTop = 40;			//上邊界
var paddingBottom = 40;			//下邊界
var lineHeight = 1.5;
var letterSpacing = 0.1;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
var bodyNode;
var mainContainer;
var containerWidth;
var containerHeight;
var imageRanges = new Array();
var debugInfo;
var contentHeight = 0;
var curTop = 0;
var pageTops = new Array();
var curPage = 1;
var totalPages = 0;
var fullWidth = 0;
var fullHeight = 0;
var textSize = 100;
//**************************************************************************
/**************** Annotation 變數 *********************/
var annotationXML;
var userSettingXML;
var startStyle = new Array();
var endTag = new Array();
var startNodeTraced = false;
var endNodeTraced = false;
var startCutOffset = 0;
var endCutOffset = 0;
var nodeFound = false;
var colorTableShown = false;
var paletteTarget;
var oriColor = "";
var ann_fontColor = "#FF0000";
var ann_bgColor = "#FFFFA0";
var ann_borderColor = "none";
var ann_textDecoration = "none";
var ann_fontWeight = "none";
var choosingColor = 0;
var idAssigned = false;
var annID = -1;
var showAnnotation = true;
var annSymbolPosition = new Array();
var annotationSymbolHeight = 40;
var isMouseInPalette = false;
var textSelectionPanel;
var textSelectionPanelOpened = false;
var colorPickerPanel;
var colorPickerPanelOpened = false;
var colorPickerState = 1;
var textSelectionOriText = "";
var highlightingNode;
var paletteScrollTimer;
var targetPaletteTop = 5;
var annotatingObj;
var callCount = 0;
var tmpSelStart = 0;
var tmpSelEnd = 0;
var itemId = "";
var tracingAnnID = false;
var tracedAnnID = new Array();
var highlightPickerPanel;
var highlightPickerPanelOpened = false;
//var targetAnnID = 8;

//跟註記有關的
var noteCache = new Array();
var iconPos = new Array();
var showNotePanel;
var noteTextContainer;
var noteIndicator;
var iconHeight = 30;
var iconAreaMargin = 30;
var showingNoteAnnID = -1;
var notePanel;
var showingNoteTextAnnID = -1;
var memoColor = 3;
var memoColorSet = new Array("",new Array("#FDFDB0", "#FEFEC9"),
								new Array("#FFD880", "#FFEAB0"),
								new Array("#FFC080", "#FFDEB0"),
								new Array("#FFB0B0", "#FFD8D8"),
								new Array("#FFB0C8", "#FFD4E8"),
								new Array("#A0F0B0", "#C8FFD0"),
								new Array("#C0D0F0", "#D8F8FF")
							);


function DOMInitialize(){
	bodyNode = document.body;
	reportToDevice("jsDebugInfo", "javascript start at DOMLoaded");
	if(typeof browserZoom != 'undefined'){
		textSize = browserZoom;
	}	
	if(inWhichPlatform == 0){
		/*
		debugInfo = document.createElement("div");
		debugInfo.setAttribute("id", "debugInfo");
		debugInfo.setAttribute("style", "border:solid 1px #888888;position:absolute;left:400px;top:50px;width:400px;height:350px;overflow:auto;font-size:10pt;");		
		bodyNode.appendChild(debugInfo);
		*/
	}
	initialSizeInfo();
	initializeImageSize();
	modifyStyle();
	bodyNode.style.paddingLeft = paddingLeft + "px";
	bodyNode.style.paddingTop = paddingTop + "px";
	try{
		$("p").css("line-height", lineHeight + "em");
		$("div").css("line-height", lineHeight + "em");
		$("p").css("letter-spacing", letterSpacing + "em");
		$("div").css("letter-spacing", letterSpacing + "em");
	}
	catch(e){
		reportToDevice("jsDebugInfo", "error @ set lineHeight:" + e);
	}
}



function initializeImageSize(){
	var maxImageWidth = (containerWidth - 20);
	var maxImageHeight = (containerHeight - 20);
	var imageNodes = document.getElementsByTagName("img");
	for(var i = 0; i < imageNodes.length; i++){
		imageNodes[i].style.maxWidth = maxImageWidth + "px";
		imageNodes[i].style.maxHeight = maxImageHeight + "px";
	}
}

function modifyStyle(){
	var spanNodes = document.getElementsByTagName("span");
	for(var i = 0; i < spanNodes.length; i++){
		spanNodes[i].style.paddingTop = "0px";
		spanNodes[i].style.paddingBottom = "0px";
	}
}


function initialSizeInfo(){
	windowSize = getWindowSize();
	fullWidth = windowSize.width;
	fullHeight = windowSize.height;
	if(typeof specifiedPaddings !== 'undefined'){
		paddingTop = specifiedPaddings[0] || paddingTop;
		paddingRight = specifiedPaddings[1] || paddingRight;
		paddingRight = Math.max(paddingRight, 40);
		paddingBottom = specifiedPaddings[2] || paddingBottom;
		paddingLeft = specifiedPaddings[3] || paddingLeft;
	}
	
	if(typeof specifiedLineHeight != 'undefined'){
		lineHeight = specifiedLineHeight;
	}
	if(typeof specifiedLetterSpacing != 'undefined'){
		letterSpacing = specifiedLetterSpacing;
	}
	
	initialWidth = fullWidth - paddingLeft - paddingRight;
	initialHeight = fullHeight - paddingTop - paddingBottom - 12;
	containerWidth = initialWidth;
	containerHeight = initialHeight;
}

function getWindowSize(){
	WS = new Object();
	if (typeof window.innerWidth != 'undefined'){
		viewportwidth = window.innerWidth,
		viewportheight = window.innerHeight
	}	// IE6 in standards compliant mode (i.e. with a valid doctype as the first line in the document)
	else if (typeof document.documentElement != 'undefined'
	&& typeof document.documentElement.clientWidth !=
	'undefined' && document.documentElement.clientWidth != 0)	{
		viewportwidth = document.documentElement.clientWidth,
		viewportheight = document.documentElement.clientHeight
	}
	// older versions of IE
	else{
		viewportwidth = document.getElementsByTagName('body')[0].clientWidth,
		viewportheight = document.getElementsByTagName('body')[0].clientHeight
	}
	
	WS.width = viewportwidth;
	WS.height = viewportheight;
	return WS;
}



function initialize(){
	//initializeImageSize();
	contentHeight = bodyNode.scrollHeight;
	
	var adjustRatio = 100;
	if(adjustScrollSize){
		adjustRatio = textSize;
	}
	if(Math.round(contentHeight * adjustRatio / 100) <= fullHeight + Math.min(3, paddingBottom)){
		reportToDevice("jsDebugInfo", "contentHeight <= fullHeight");
		totalPages = 1;
	}
	else{
		reportToDevice("jsDebugInfo", "contentHeight = " + contentHeight + ", fullHeight = " + fullHeight);
		bodyNode.setAttribute("style", "background-attachment:fixed;padding-top:" + paddingTop + "px;padding-left:" + paddingLeft + "px;"
										+	"max-height:" + containerHeight + "px;"
										+	"height:" + containerHeight + "px;"
										+	"width:" + (containerWidth * 2 + paddingLeft + paddingRight) + "px;"
										//+	"min-width:" + scrollWidth + "px;"
										+	"-webkit-column-gap:" + (paddingLeft + paddingRight) + "px;"
										+	"-webkit-column-width:" + (containerWidth) + "px;");
		scrollWidth = bodyNode.scrollWidth;
		reportToDevice("jsDebugInfo", "bodyNode.scrollWidth = " + bodyNode.scrollWidth + ", containerWidth = " + containerWidth);
		totalPages = Math.round((scrollWidth * adjustRatio / 100 + paddingRight) / (containerWidth + paddingLeft + paddingRight));	
		reportToDevice("jsDebugInfo", "totalPages = " + totalPages);
	}
	//Add a transparent block to the tail of this node
	var trashDiv = document.createElement("div");
	trashDiv.setAttribute("style", "position:absolute;left:" + Math.round(bodyNode.scrollWidth * adjustRatio / 100) + "px;top:0px;width:" + paddingRight + "px;height:30px;");
	bodyNode.appendChild(trashDiv);
			
	reportToDevice("reportTotalPages", totalPages);
	
	if(typeof targetPage != 'undefined'){		
		reportToDevice("jsDebugInfo", "get targetPage = " + targetPage);		
		if(targetPage != null){
			showPage(targetPage);
		}
	}		
	
	try{
		assignElementsId(bodyNode, '0');
		initializeXML();
	}
	catch(e){
		reportToDevice("jsDebugInfo", "error @1:" + e);
	}
	if(typeof targetAnnID != 'undefined'){
		reportToDevice("jsDebugInfo", "get targetAnnID = " + targetAnnID);		
		setTimeout('jumpToAnnotation(' + targetAnnID + ')', 200);
	}
	
}

function assignElementsId(curNode, depthStr){
	var addedChild = 0;
	var tmp = curNode.childNodes.length;
	for(var i = 0; i < tmp; i++){
		var tmpChildNode = curNode.childNodes[i];
		var lowerNodeName = tmpChildNode.nodeName.toLowerCase();
		if(lowerNodeName === "#text"){
			continue;
		}
		else if((lowerNodeName === "#comment") || (lowerNodeName === "script")){
			continue;
			//Do nothing
		}
		else{
			
			try{
				if(lowerNodeName === "p"){
					//tmpChildNode.setAttribute("onclick", "showColorPickerPanel(this)");
					tmpChildNode.setAttribute("onclick", "showMenu(this)");
					
				}
				else if(lowerNodeName.substring(0, 1) === "h"){
					//tmpChildNode.setAttribute("onclick", "showColorPickerPanel(this)");
					tmpChildNode.setAttribute("onclick", "showMenu(this)");
				}
				else if(lowerNodeName == "a"){
					tmpChildNode.removeAttribute("href");
				}
			}
			catch(e){
				reportToDevice("alert", "e:" + e + "@3.1");
			}
			if(lowerNodeName.indexOf("meta") >= 0){
				break;
			}
			myDepthStr = depthStr + ";" + (addedChild++);
			var myId = depthStrToId(myDepthStr);
			try{
				tmpChildNode.setAttribute("id", myId);
			}
			catch(e){
				reportToDevice("alert", "e:" + e + "@3.3");
			}
			//depthPath[depthPathCount++] = myDepthStr;
			assignElementsId(tmpChildNode, myDepthStr);
		}
	}
}


function showPage(page){
	var adjustRatio = 100;
	if(adjustScrollSize){
		adjustRatio = textSize;
	}
	
	if((page >= 1) && (page <= totalPages)){
		curPage = page;
		var PN = document.getElementById("pageNum");
		if(PN != null){
			PN.innerHTML = curPage + "/" + totalPages;
		}
		//var targetLeft = paddingLeft - (containerWidth + paddingLeft + paddingRight) * (curPage - 1);
		targetLeft = (containerWidth + paddingLeft + paddingRight) * (curPage - 1);
		
		try{
			//bodyNode.scrollTo(targetLeft, 0);
			bodyNode.scrollLeft = Math.round(targetLeft * 100 / adjustRatio);
		}
		catch(e){
			reportToDevice("jsDebugInfo", "e:" + e);
		}
		/*
		mainContainer.style.left = targetLeft + "px";
		reportToDevice("jsDebugInfo", "showPage(" + curPage + "), move left to:" + targetLeft);
		*/
	}
}

function drawCutLine(yPos, color){
	if(color == null){
		color = "#FF0000";
	}
	var checkLine = document.createElement("div");
	checkLine.setAttribute("style", "position:absolute;top:" + yPos + "px;left:0px;width:200px;height:30px;border-top:solid 1px " + color + ";");
	bodyNode.appendChild(checkLine);
}

function reportToDevice(){
	var operation = arguments[0];
	if(inWhichPlatform === 1){	//Anroid
		if(operation === "pagesReady"){
			if(arguments.length >= 2){
				window.demo.reportPagesReady(arguments[1]);
			}
		}
		else if(operation === "resultXML"){
			if(arguments.length >= 2){
				window.demo.reportResultXml(arguments[1]);
			}
		}
		
		else if(operation == "displayTextSelector"){
			//displayTextSelector(boolean display, int left, int top, int width, int height, String text, int startIndex, int endIndex)
			if(arguments.length >= 2){
				if(arguments[1]){
					if(arguments.length == 7){	//create highlight
						window.demo.displayTextSelector(true, 			//display
														arguments[2],	//left
														arguments[3],	//top
														arguments[4], 	//width
														arguments[5],	//height
														arguments[6], 	//text
														-1,				//startIndex
														-1				//endIndex
														);
					}
					else if(arguments.length == 9){		//create highlight
						window.demo.displayTextSelector(true, 			//display
														arguments[2],	//left
														arguments[3],	//top
														arguments[4], 	//width
														arguments[5],	//height
														arguments[6], 	//text
														arguments[7],	//startIndex
														arguments[8] 	//endIndex
														);
					}
				}
				else{
					window.demo.displayTextSelector(false, 0, 0, 0, 0, "", -1, -1);
				}
			}	
		}
		else if(operation == "updateAnnotation"){
			//reportToDevice("jsDebugInfo", "send updateAnnotation");
			if(arguments.length >= 11){
				window.demo.updateAnnotation(	arguments[1],		//text
												arguments[2],		//startIndex
												arguments[3],		//endIndex
												RGBtoARGB(arguments[4]), 		//fontColor
												RGBtoARGB(arguments[5]),		//bgColor
												RGBtoARGB(arguments[6]), 		//borderColor
												arguments[7],		//textDecoration
												arguments[8],		//fontWeight
												arguments[9],		//noteText
												arguments[10]		//updateAnnID												
												);
			}
		}
		else if(operation === "hideNote"){
			window.demo.hideNote();
		}
		else if(operation === "reportAnnotation"){
			if(arguments.length >= 2){
				window.demo.reportAnnotation(arguments[1]);
				reportToDevice("jsDebugInfo", arguments[1]);
			}
		}
		else if(operation === "reportImagePos"){
			if(arguments.length >= 3){
				window.demo.reportImagePos(arguments[1], arguments[2]);
			}
		}
		else if(operation === "detectEmptyRow"){
			if(arguments.length >= 2){
				window.demo.detectEmptyRow(arguments[1]);
			}
		}
		else if(operation === "nodeInitialized"){
			window.demo.nodeInitialized();
		}
		else if(operation === "reportCurPage"){
			if(arguments.length >= 2){
				window.demo.reportCurPage(arguments[1]);
			}
		}
		else if(operation === "reportNoteIconPos"){
			if(arguments.length >= 3){
				window.demo.reportNoteIconPos(arguments[1], arguments[2]);
			}
		}
		else if(operation === "displayFirstPage"){
			if(arguments.length >= 2){
				window.demo.displayFirstPage(arguments[1]);
			}
		}
		else if(operation === "reportPageHTML"){
			if(arguments.length >= 3){
				window.demo.reportPageHTML(arguments[1], arguments[2]);
			}
		}
		else if(operation === "reportCurPos"){
			if(arguments.length >= 3){
				window.demo.reportCurPos(arguments[1], arguments[2]);
			}
		}
		else if(operation == "reportTotalPages"){
			if(arguments.length >= 2){
				window.demo.reportTotalPages(arguments[1]);
			}
		}
		else if(operation == "jsDebugInfo"){
			if(arguments.length >= 2){
				window.demo.jsDebugInfo(arguments[1]);
			}
		}
	}
	else if(inWhichPlatform == 0){	
		if(operation == "jsDebugInfo"){
			//var DI = document.getElementById("debugInfo");
			//DI.innerHTML += arguments[1] + "<br/>\n";
		}
	}
}

function prevPage(){
	if(curPage > 1){
		showPage(curPage - 1);
	}
}

function nextPage(){
	if(curPage < totalPages){
		showPage(curPage + 1);
	}
}

//==================== annotation 相關function =============================


function jumpToAnnotation(jumpAnnID){
	try{
		var isParagraphNote = false;
		var paragraphID = "";
		for(var i = 0; i < annotationXML.childNodes[0].childNodes.length; i++){
			if(annotationXML.childNodes[0].childNodes[i].nodeName === "Annotation"){
				if(parseInt(annotationXML.childNodes[0].childNodes[i].getAttribute("annID")) === jumpAnnID){
					
					annNode = annotationXML.childNodes[0].childNodes[i];
					var startNodeId = "";
					var endNodeId = "";
					var startOffset = 0;
					var endOffset = 0;
					for(var j = 0; j < annNode.childNodes.length; j++){
						if(annNode.childNodes[j].nodeName == "Start"){
							startNodeId = annNode.childNodes[j].getAttribute("nodeID");
							startOffset = parseInt(annNode.childNodes[j].getAttribute("offset"));
						}
						else if(annNode.childNodes[j].nodeName == "End"){
							endNodeId = annNode.childNodes[j].getAttribute("nodeID");
							endOffset = parseInt(annNode.childNodes[j].getAttribute("offset"));
						}
					}
					if(startNodeId == endNodeId){
						if(startOffset == endOffset){
							isParagraphNote = true;
							paragraphID = startNodeId;
							break;
						}
					}
				}	
			}
		}
		
		if(isParagraphNote){
			var realPage = getPageByX($('#' + paragraphID).offset().left, true);
			showPage(realPage);
			reportToDevice("reportCurPage", realPage);
		}
		else{
			var spanNodes = document.getElementsByTagName("span");
			var realPage = 0;
			var realY = 0;
			for(var i = 0; i < spanNodes.length; i++){
				if(spanNodes[i].getAttribute("annID") != null){
					var tmpAnnID = spanNodes[i].getAttribute("annID");
					var tmpAnnIDNum = parseInt(tmpAnnID.substring(5));
					if(tmpAnnIDNum == jumpAnnID){
						debugInfo += (tmpAnnID + ",\n");
						
						var posDetector = document.createElement("font");
						if(spanNodes[i].childNodes.length === 0){
							spanNodes[i].appendChild(posDetector);
						}
						else{
							spanNodes[i].insertBefore(posDetector, spanNodes[i].childNodes[0]);
						}
						
						var tmpPage = getPageByX($(posDetector).offset().left, true);
						var tmpY = $(posDetector).offset().top;
						//var realHeight = posDetector.offsetHeight;
						//reportToDevice("jsDebugInfo", tmpAnnIDNum + "(h):" + spanNodes[i].offsetHeight);
						spanNodes[i].removeChild(posDetector);
						
						if(realPage == 0){
							realPage = tmpPage;
							realY = tmpY;
						}
						else if(realPage === tmpPage){
							realY = Math.min(tmpY, realY);
						}
						else if(realPage > tmpPage){
							realPage = tmpPage;
							realY = tmpY;
						}
					}
				}
			}
			if(realPage > 0){
				showPage(realPage);	
				reportToDevice("reportCurPage", realPage);
				
			}
		}
		//analyzeHighlightPositions();
	}
	catch(e){
		reportToDevice("jsDebugInfo", "error@jumpToAnnotation:" + e);
	}
}



//----------- XML處理相關function ------------------------
function createXMLDocument(xmlString) {
	var xmlDoc = null;
	if (window.DOMParser) {
		var parser = new DOMParser();
		xmlDoc = parser.parseFromString(xmlString, "text/xml");
	} else if (window.ActiveXObject) {
		xmlDoc = new ActiveXObject ("Microsoft.XMLDOM");
		xmlDoc.async = false;
		xmlDoc.loadXML (xmlString);
	}
	return xmlDoc;
}


function xmlToStr(node, out) {
	if(typeof out === "undefined"){
		out = "";
	}
	if(node.nodeName.toLowerCase() === "#text"){
		if(node.nodeValue.trim().length > 0){
			out+= node.nodeValue;
		}
	}
	else{	
		out += "<"+node.nodeName;
		if (node.attributes!=null) {
			for (var i=0; i<node.attributes.length; i++) {
				var item = node.attributes.item(i);
				var value = item.nodeValue;
				if (value==null) value = "";
				out += " "+item.nodeName+"=\""+value+"\"";
			}
		}
		if(node.childNodes.length === 0){
			out += "/>\n";
		}
		else{
			out += ">";
			if(node.childNodes[0].nodeName != "#text"){
				out += "\n";
			}
			for (var i=0; i< node.childNodes.length; i++) {
				out = xmlToStr(node.childNodes[i], out);
			}
			out += "</" + node.nodeName + ">\n";
		}
	}
	return out;
}

//-------------------------------------------------------


function depthStrToId(str){
	var indexes = str.split(";");
	var outputStr = "__node_" + indexes[0];
	for(var i = 1; i < indexes.length; i++){
		outputStr += "_" + indexes[i];
	}
	return outputStr;
}


function showMenu(targetObj){
	try{
		if(tracingAnnID){
			tracingAnnID = false;
		}
		highlightingNode = targetObj;
		var e = event;
		var mouseX = 0;
		var mouseY = 0;
		if (document.layers) {
			mouseX = e.pageX;
			mouseY = e.pageY;
		}
		else{
			mouseX = e.clientX;
			mouseY = e.clientY;
		}
		showHighlightPickerPanel(mouseX, mouseY);
	}
	catch(e){
		reportToDevice("jsDebugInfo", "error @2:" + e);
	}
}

function showHighlightPickerPanel(x, y){
	/*
	if(highlightPickerPanelOpened){
		return false;
	}
	*/
	openNotePanel(-1);
	var triangleDirection = "";
	if(typeof highlightPickerPanel == 'undefined'){
		genHighlightPickerPanel();
	}
	if(typeof showNotePanel != 'undefined'){
		showNotePanel.style.visibility = "hidden";
	}
	var bZoom = textSize;
	
	highlightPickerPanel.style.visibility = "visible";
	var HLPPI = document.getElementById("HLPPIndicator");
	var HLPPBG = document.getElementById("HLPPBG");
	var panelX = Math.max(20, Math.min(fullWidth - 200 - 40, x - 100)) + bodyNode.scrollLeft / (bodyNode.scrollWidth / (fullWidth * totalPages));
	var panelY = 0;
	if(y < 250){
		panelY = y + 18;
		HLPPI.style.top = "-5px";
		HLPPI.style.backgroundColor = "#484848";
		triangleDirection = "up";
		highlightPickerPanel.style.top = panelY + "px";
	}
	else{		
		panelY = y - 220;
		HLPPI.style.top = "193px";
		HLPPI.style.backgroundColor = "#000000";
		triangleDirection = "down";
		//highlightPickerPanel的top座標改在算出總項目數時再指定
	}
	HLPPI.style.left = (Math.max(x - panelX, Math.min(100, x - 20)) - 5) + "px";
	highlightPickerPanel.style.left = panelX + "px";
	//highlightPickerPanel.style.top = panelY + "px";	
	
	
	HLPPBG.innerHTML = "";
	
	var textSelectionOriText = getAllTextOfANode(highlightingNode);
	
	var annXMLRoot = annotationXML.childNodes[0];
	var annCount = 0;
	for(var i = tracedAnnID.length - 1; i >= 0; i--){
		var tmpAnnID = parseInt(tracedAnnID[i].substring(5));
		for(var j = 0; j < annXMLRoot.childNodes.length; j++){
			if(annXMLRoot.childNodes[j].nodeName == "Annotation"){
				if(parseInt(annXMLRoot.childNodes[j].getAttribute("annID")) == tmpAnnID){
					//進入Annotation層
					//先找offset
					annCount++;
					var startOffset = 0;
					var endOffset = 0;
					var attachedText = "";
					var sampleTextContainer = document.createElement("span");
					var curAnnotationNode = annXMLRoot.childNodes[j];
					var tmp_fontColor, tmp_bgColor, tmp_borderColor, tmp_textDecoration, tmp_fontWeight;
					for(var k = 0; k < curAnnotationNode.childNodes.length; k++){
						if(curAnnotationNode.childNodes[k].nodeName == "Start"){
							startOffset = parseInt(curAnnotationNode.childNodes[k].getAttribute("offset"));
						}
						else if(curAnnotationNode.childNodes[k].nodeName == "End"){
							endOffset = parseInt(curAnnotationNode.childNodes[k].getAttribute("offset"));
						}
						else if(curAnnotationNode.childNodes[k].nodeName == "ShowType"){
							if(curAnnotationNode.childNodes[k].getAttribute("type") == "highlight"){
								sampleTextContainer.style.color = (curAnnotationNode.childNodes[k].getAttribute("foregroundColor") == "none")?"#000000":curAnnotationNode.childNodes[k].getAttribute("foregroundColor");
								sampleTextContainer.style.backgroundColor = (curAnnotationNode.childNodes[k].getAttribute("backgroundColor") == "none")?"transparent":curAnnotationNode.childNodes[k].getAttribute("backgroundColor");
								tmp_fontColor = curAnnotationNode.childNodes[k].getAttribute("foregroundColor");
								tmp_bgColor = curAnnotationNode.childNodes[k].getAttribute("backgroundColor");
							}
							else if(curAnnotationNode.childNodes[k].getAttribute("type") == "border"){
								sampleTextContainer.style.border = (curAnnotationNode.childNodes[k].getAttribute("borderColor") == "none")?"none":("solid 1px " + curAnnotationNode.childNodes[k].getAttribute("borderColor"));
								tmp_borderColor = curAnnotationNode.childNodes[k].getAttribute("borderColor")
							}
							else if(curAnnotationNode.childNodes[k].getAttribute("type") == "textDecoration"){
								sampleTextContainer.style.textDecoration = curAnnotationNode.childNodes[k].getAttribute("lineType");
								tmp_textDecoration = curAnnotationNode.childNodes[k].getAttribute("lineType");
							}
							else if(curAnnotationNode.childNodes[k].getAttribute("type") == "fontWeight"){
								sampleTextContainer.style.fontWeight = (curAnnotationNode.childNodes[k].getAttribute("weight") == "none")?"normal":curAnnotationNode.childNodes[k].getAttribute("weight");
								tmp_fontWeight = curAnnotationNode.childNodes[k].getAttribute("weight");
							}
						}
						else if(curAnnotationNode.childNodes[k].nodeName == "AttachedText"){
							if(curAnnotationNode.childNodes[k].childNodes[0] != null){
								if(curAnnotationNode.childNodes[k].childNodes[0].nodeName.toLowerCase() == "#text"){
									attachedText = curAnnotationNode.childNodes[k].childNodes[0].nodeValue;
								}
							}
						}
					}
					
					noteCache[tmpAnnID] = attachedText;
					var exampleText = "";
					if(endOffset - startOffset > 8){
						exampleText = textSelectionOriText.substring(startOffset, startOffset + 4)
									+ " ... "
									+ textSelectionOriText.substring(endOffset - 3, endOffset);
					}
					else{
						exampleText = textSelectionOriText.substring(startOffset, endOffset);
					}					
					sampleTextContainer.innerHTML = exampleText;
					
					
					var annotationListItem = document.createElement("div");
					annotationListItem.style.overflow = "hidden";
					
					
					//刪除按鈕
					var delHighlightBtn = document.createElement("span");
					delHighlightBtn.setAttribute("style", 'text-align:center;vertical-align:bottom;text-align:center;padding-left:3px;position:relative;top:-5px;'
														+  'font-size:' + Math.ceil(12 * 100/ bZoom) + 'pt;-webkit-border-radius:20px;font-weight:bolder;-webkit-box-shadow: 1px 1px 3px #000000;'
														+  'color:#FFFFFF;background:-webkit-gradient(linear, left top, left bottom, from(#FF6058), to(#A00000));cursor:pointer;'
														+  'overflow:hidden;text-align:left;display:inline-block;width:15px;border:solid 2px #FFFFFF;');
					delHighlightBtn.setAttribute("onclick", "delHighlight(" + tmpAnnID + ")");
					delHighlightBtn.innerHTML = "－";
					annotationListItem.appendChild(delHighlightBtn);
								
					
					
								
					//編輯按鈕
					var editHighlightBtn = document.createElement("span");
					editHighlightBtn.appendChild(sampleTextContainer);
					editHighlightBtn.setAttribute("style", 'height:26px;vertical-align:bottom;margin-bottom:3px;margin-left:3px;text-align:center;'
														+  'font-size:' + Math.ceil(13 * 100/ bZoom) + 'pt;padding:0px 2px;-webkit-border-radius:3px;-webkit-box-shadow: 1px 1px 3px #000000;'
														+  'color:#222222;background:-webkit-gradient(linear, left top, left bottom, from(#FFFFFF), to(#E8E8E8));cursor:pointer;'
														+  'overflow:hidden;text-align:left;display:inline-block;width:160px;');
					//createHighlightBtn.setAttribute("onclick", 'showColorPickerPanel()');
					editHighlightBtn.setAttribute("onclick", "editAnnotation(highlightingNode, " + startOffset + ", " + endOffset + ", '"
															+ tmp_fontColor + "', '" + tmp_bgColor + "', '" + tmp_borderColor + "', '"
															+ tmp_textDecoration + "', '" + tmp_fontWeight + "', " + tmpAnnID + ")");
					
					annotationListItem.appendChild(editHighlightBtn);
					
					//註記按鈕
					var showNoteBtn = document.createElement("span");
					if(attachedText.length > 0){
						showNoteBtn.setAttribute("style", 'text-align:center;vertical-align:bottom;text-align:center;padding-left:3px;margin-left:2px;position:relative;top:-5px;'
															+  'font-size:' + Math.ceil(12 * 100/ bZoom) + 'pt;-webkit-border-radius:5px;font-weight:bolder;-webkit-box-shadow: 1px 1px 3px #000000;'
															+  'color:#000000;background:-webkit-gradient(linear, left top, left bottom, from(#FFFFE0), to(#FFFF90));cursor:pointer;'
															+  'overflow:hidden;text-align:left;display:inline-block;width:15px;border:solid 1px #000000;');					
						showNoteBtn.setAttribute("onclick", "showNote(" + tmpAnnID + ", " + annCount + ")");
					}
					else{
						showNoteBtn.setAttribute("style", 'text-align:center;vertical-align:bottom;text-align:center;padding-left:3px;margin-left:2px;position:relative;top:-5px;'
															+  'font-size:' + Math.ceil(12 * 100/ bZoom) + 'pt;-webkit-border-radius:5px;font-weight:bolder;-webkit-box-shadow: 1px 1px 3px #000000;'
															+  'color:#000000;background:-webkit-gradient(linear, left top, left bottom, from(#303028), to(#202010));'
															+  'overflow:hidden;text-align:left;display:inline-block;width:15px;border:solid 1px #202020;');
					}
					showNoteBtn.innerHTML = "A";
					annotationListItem.appendChild(showNoteBtn);	
					
					
					HLPPBG.appendChild(annotationListItem);
					//reportToDevice("alert", startOffset + " to " + endOffset);
					break;
				}
			}
		}
	}
	
	var tmpPanelHeight = ((annCount + 3) * 29 - 10);
	HLPPBG.style.height = tmpPanelHeight + "px";
	if(triangleDirection == "down"){	
		HLPPI.style.top = (tmpPanelHeight + 14) + "px";
		highlightPickerPanel.style.top = (y - tmpPanelHeight - 36) + "px";
	}
	/*
	var tmpBtnContainer = document.createElement("div");
	tmpBtnContainer.setAttribute("style", "width:100%;height:24px;");
	HLPPBG.appendChild(tmpBtnContainer);
	*/
	// ===== 新增標記 ======
	var annotationListItem = document.createElement("div");
	annotationListItem.style.overflow = "hidden";	
	//新增標記(icon)
	var iconBtn = document.createElement("span");
	iconBtn.setAttribute("style", 'visibility:hidden;text-align:center;vertical-align:bottom;text-align:center;padding-left:3px;position:relative;top:-5px;'
										+  'font-size:' + Math.ceil(12 * 100/ bZoom) + 'pt;-webkit-border-radius:20px;font-weight:bolder;-webkit-box-shadow: 1px 1px 3px #000000;'
										+  'color:#FFFFFF;background:-webkit-gradient(linear, left top, left bottom, from(#30A000), to(#008000));cursor:pointer;'
										+  'overflow:hidden;text-align:left;display:inline-block;width:15px;border:solid 2px #FFFFFF;');
	iconBtn.setAttribute("onclick", "createAnnotation()");
	iconBtn.innerHTML = "＋";										
	//新增標記(文字)
	var editHighlightBtn = document.createElement("span");
	editHighlightBtn.innerHTML = "新增標記";
	editHighlightBtn.setAttribute("style", 'height:26px;vertical-align:bottom;margin-bottom:3px;margin-left:3px;text-align:center;'
										+  'font-size:' + Math.ceil(13 * 100/ bZoom) + 'pt;padding:0px 2px;-webkit-border-radius:3px;-webkit-box-shadow: 1px 1px 3px #000000;'
										+  'color:#222222;background:-webkit-gradient(linear, left top, left bottom, from(#DCF8E0), to(#C0F0D0));cursor:pointer;'
										+  'overflow:hidden;text-align:left;display:inline-block;width:160px;');
	editHighlightBtn.setAttribute("onclick", "createAnnotation()");
	annotationListItem.appendChild(iconBtn);
	annotationListItem.appendChild(editHighlightBtn);	
	HLPPBG.appendChild(annotationListItem);
	
	// ===== 新增段落註記 ======
	var annotationListItem = document.createElement("div");
	annotationListItem.style.overflow = "hidden";	
	//新增段落註記(icon)
	var iconBtn = document.createElement("span");
	iconBtn.setAttribute("style", 'visibility:hidden;text-align:center;vertical-align:bottom;text-align:center;padding-left:3px;position:relative;top:-5px;'
										+  'font-size:' + Math.ceil(12 * 100/ bZoom) + 'pt;-webkit-border-radius:20px;font-weight:bolder;-webkit-box-shadow: 1px 1px 3px #000000;'
										+  'color:#FFFFFF;background:-webkit-gradient(linear, left top, left bottom, from(#30A000), to(#008000));cursor:pointer;'
										+  'overflow:hidden;text-align:left;display:inline-block;width:15px;border:solid 2px #FFFFFF;');
	iconBtn.innerHTML = "＋";										
	//新增段落註記(文字)
	var editHighlightBtn = document.createElement("span");
	editHighlightBtn.innerHTML = "新增段落註記";
	editHighlightBtn.setAttribute("style", 'height:26px;vertical-align:bottom;margin-bottom:3px;margin-left:3px;text-align:center;'
										+  'font-size:' + Math.ceil(13 * 100/ bZoom) + 'pt;padding:0px 2px;-webkit-border-radius:3px;-webkit-box-shadow: 1px 1px 3px #000000;'
										+  'color:#222222;background:-webkit-gradient(linear, left top, left bottom, from(#DCF8E0), to(#C0F0D0));cursor:pointer;'
										+  'overflow:hidden;text-align:left;display:inline-block;width:160px;');
	editHighlightBtn.setAttribute("onclick", "createNote()");
	annotationListItem.appendChild(iconBtn);
	annotationListItem.appendChild(editHighlightBtn);	
	HLPPBG.appendChild(annotationListItem);
	
	
	
	// ===== 關閉 ======
	var annotationListItem = document.createElement("div");
	annotationListItem.style.overflow = "hidden";	
	//關閉(icon)
	var iconBtn = document.createElement("span");
	iconBtn.setAttribute("style", 'visibility:hidden;font-family:Arial;text-align:center;vertical-align:bottom;text-align:center;padding-left:3px;position:relative;top:-5px;'
										+  'font-size:' + Math.ceil(12 * 100/ bZoom) + 'pt;-webkit-border-radius:20px;font-weight:bolder;-webkit-box-shadow: 1px 1px 3px #000000;'
										+  'color:#FFFFFF;background:-webkit-gradient(linear, left top, left bottom, from(#A03030), to(#701010));cursor:pointer;'
										+  'overflow:hidden;text-align:left;display:inline-block;width:15px;border:solid 2px #FFFFFF;');
	iconBtn.setAttribute("onclick", "showColorPickerPanel()");
	iconBtn.innerHTML = "X";										
	//關閉(文字)
	var editHighlightBtn = document.createElement("span");
	editHighlightBtn.innerHTML = "關閉";
	editHighlightBtn.setAttribute("style", 'height:26px;vertical-align:bottom;margin-bottom:3px;margin-left:3px;text-align:center;'
										+  'font-size:' + Math.ceil(13 * 100/ bZoom) + 'pt;padding:0px 2px;-webkit-border-radius:3px;-webkit-box-shadow: 1px 1px 3px #000000;'
										+  'color:#222222;background:-webkit-gradient(linear, left top, left bottom, from(#D0D0F8), to(#A0C0FF));cursor:pointer;'
										+  'overflow:hidden;text-align:left;display:inline-block;width:160px;');
	editHighlightBtn.setAttribute("onclick", "hideHighlightPickerPanel()");
	annotationListItem.appendChild(iconBtn);
	annotationListItem.appendChild(editHighlightBtn);	
	HLPPBG.appendChild(annotationListItem);
	
	tracedAnnID = new Array();
	
	highlightPickerPanelOpened = true;
}


function editAnnotation(targetObj, startIndex, endIndex, fontColor, bgColor, borderColor, textDecoration, fontWeight, editingAnnID){
	/*
	showColorPickerPanel(highlightingNode, " + startOffset + ", " + endOffset + ", '"
															+ tmp_fontColor + "', '" + tmp_bgColor + "', '" + tmp_borderColor + "', '"
														+ tmp_textDecoration + "', '" + tmp_fontWeight + "', " + tmpAnnID + ")");
	*/
	var textSelectionOriText = "";
	try{	
		targetObj = highlightingNode;
		
        colorPickerPanelOpened = true;
        textSelectionOriText = getAllTextOfANode(targetObj);
        if(textSelectionOriText.length == 0){
            colorPickerPanelOpened = false;
            return false;
        }
	}
    catch(e){
		reportToDevice("jsDebugInfo", "error@editAnnotation:" + e);
        alert(e);
    }
	reportToDevice("updateAnnotation", textSelectionOriText, startIndex, endIndex, fontColor, bgColor, borderColor, textDecoration, fontWeight, (noteCache[editingAnnID] == null)?"":noteCache[editingAnnID], editingAnnID);
	hideHighlightPickerPanel();
															
}


function createAnnotation(){
	/*
	updateAnnotation(	String text, int startIndex, int endIndex, String fontColor, String bgColor, String borderColor, 
									String textDecoration, String fontWeight, String noteText, int updateAnnID){
	*/
	var textSelectionOriText = "";
	try{	
		targetObj = highlightingNode;
		
        colorPickerPanelOpened = true;
        textSelectionOriText = getAllTextOfANode(targetObj);
        if(textSelectionOriText.length == 0){
            colorPickerPanelOpened = false;
            return false;
        }
	}
    catch(e){
		reportToDevice("jsDebugInfo", "error@createAnnotation:" + e);
        alert(e);
    }    
	reportToDevice("updateAnnotation", textSelectionOriText, -1, -1, ann_fontColor, ann_bgColor, ann_borderColor, "none", "none", "", -1);
	hideHighlightPickerPanel();
}


//計算highlight位置，在右邊貼小便利貼
function analyzeHighlightPositions(){
	var debugInfo = "";
	var symbolInfo = new Array();
	var x = 0;
	var maxPages = 0;
	reportToDevice("jsDebugInfo", "curPage = " + curPage);
	var spanNodes = document.getElementsByTagName("span");
	for(var i = 0; i < spanNodes.length; i++){
		if(spanNodes[i].getAttribute("annID") != null){
			var tmpAnnID = spanNodes[i].getAttribute("annID");
			var tmpAnnIDNum = parseInt(tmpAnnID.substring(5));
			debugInfo += (tmpAnnID + ",\n");
			if(noteCache[tmpAnnIDNum] == null){
				continue;
			}
			else if(noteCache[tmpAnnIDNum].length === 0){
				continue;
			}
			var posDetector = document.createElement("font");
			if(spanNodes[i].childNodes.length === 0){
				spanNodes[i].appendChild(posDetector);
			}
			else{
				spanNodes[i].insertBefore(posDetector, spanNodes[i].childNodes[0]);
			}
			
			var realPage = getPageByX($(posDetector).offset().left, true);
			var realY = $(posDetector).offset().top;
			
			if(realY >= fullHeight){
				realPage += Math.floor(realY / fullHeight);
				realPage2 += Math.floor(realY / fullHeight);
				realY = realY % fullHeight;
			}
			
			//var realHeight = posDetector.offsetHeight;
			spanNodes[i].removeChild(posDetector);
			
			var found = false;
			for(var s = 0; s < symbolInfo.length; s++){
				if(symbolInfo[s][0] == tmpAnnIDNum){
					found = true;
					if(symbolInfo[s][1] === realPage){
						symbolInfo[s][2] = Math.min(symbolInfo[s][2], realY);
					}
					else if(symbolInfo[s][1] > realPage){
						symbolInfo[s][1] = realPage;
						symbolInfo[s][2] = realY;
					}
					break;
				}
			}
			if(!found){
				symbolInfo.push(new Array(tmpAnnIDNum, realPage, realY));
			}
		}
	}
	
	//clear exist notes
	var tmpRemovedCounter = 0;
	$.each($('div[noteAnnID]'), function(n){
		try{
			//$(this).css('left', (parseInt($(this).attr('oriLeft')) + iconOffset) + "px");
			this.parentNode.removeChild(this);
			tmpRemovedCounter++;
		}
		catch(e){
			reportToDevice("alert", e);
		}
	});
	
	if(symbolInfo.length == 0){
		return true;
	}
	
	symbolInfo.sort(sortPos);
	maxPages = symbolInfo[symbolInfo.length - 1][1];
	
	iconPos = new Array();
	for(var p = 1; p <= maxPages; p++){
		iconPos[p] = new Array();
	}
	//依頁數分為數個子array
	for(var s = 0; s < symbolInfo.length; s++){
		iconPos[symbolInfo[s][1]].push(new Array(symbolInfo[s][0], symbolInfo[s][2]));
	}
	//做位置規劃，避免疊在一起
	var maxTop = iconAreaMargin;
	var maxBottom = fullHeight - iconAreaMargin;
	var generatedIcons = 0;	
	
    //合成各頁小memo圖示的位置資訊，供App判斷是點在圖示的位置還是要換頁
    var noteIconPosStr = "";
	
	for(var p = 1; p <= maxPages; p++){
		
		if(iconPos[p].length === 0){	//此頁無註記
			continue;
		}
		var curBottom = 0;
		for(var i = 0; i < iconPos[p].length; i++){
			if(iconPos[p][i][1] < curBottom){
				iconPos[p][i][1] = curBottom;
			}
			curBottom = iconPos[p][i][1] + iconHeight;			
		}
		if(curBottom > maxBottom){	//排完後發生擠到底的情況，由最後一個往上推
			var curTop = maxBottom;
			for(var i = iconPos[p].length - 1; i >= 0; i--){
				if(iconPos[p][i][1] + iconHeight > curTop){
					iconPos[p][i][1] = curTop - iconHeight;
				}
				curTop = iconPos[p][i][1];
			}
		}
		if(curTop < maxTop){	//可能發生完全擠不進去的情況，要重分配iconHeight，再另外做
			
		}
		
		//reportToDevice("alert", "tmpRemovedCounter = " + tmpRemovedCounter);
		//此頁規劃完了，直接畫在畫面上		
		var iconLeft = p * fullWidth - paddingRight + 4;	//icon的x座標
		//var realIconLeft = (p - curPage + 1) * fullWidth - paddingRight + 4;
		var realIconLeft = p * fullWidth - paddingRight + 4;
		
		for(var i = 0; i < iconPos[p].length; i++){
			var noteIcon = document.createElement("div");
			noteIcon.setAttribute("noteAnnID", iconPos[p][i][0]);
			noteIcon.setAttribute("oriLeft", iconLeft);
			noteIcon.setAttribute("style", "position:absolute;left:" + realIconLeft + "px;top:" + iconPos[p][i][1] + "px;width:25px;height:25px;"
										+  "background:-webkit-gradient(linear, left top, left bottom, from(" + memoColorSet[memoColor][0] + "), to(" + memoColorSet[memoColor][1] + "));cursor:pointer;background-color:" + memoColorSet[memoColor][1] + ";"
										+  "border-bottom:solid 1px #888888;z-index:" + (20000 + generatedIcons) + ";font-size:9pt;-webkit-box-shadow: 0px 1px 4px #333333;");
			noteIcon.setAttribute("onclick", "openNotePanel(" + iconPos[p][i][0] + ")");
			bodyNode.appendChild(noteIcon);
            noteIconPosStr += p + "," + iconPos[p][i][1] + "," + iconPos[p][i][0] + ";";
			generatedIcons++;
		}
	}
	
	reportToDevice("jsDebugInfo", noteIconPosStr);
	reportToDevice("reportNoteIconPos", fullHeight, noteIconPosStr);
	/*
	var note = document.createElement("div");
	note.innerHTML = debugInfo;
	note.setAttribute("style", "position:absolute;left:0px;top:0px;color:#FF0000;background-color:#FFFFFF;font-size:9pt;");
	document.body.appendChild(note);
	*/
}

function sortPos(a,b){
	if(a[1] === b[1]){
		if(a[2] === b[2]){
			return a[0] - b[0];
		}
		else{
			return a[2] - b[2];
		}
	}
	else{
		return a[1] - b[1];
	}
}

function getPageByX(x, ignoreCurPage){
	var pageWidth = paddingLeft + paddingRight + containerWidth;
	var outputPage = 1;
	if(typeof ignoreCurPage != 'undefined'){
		outputPage = Math.max(1, Math.ceil(x / pageWidth));
	}
	else{
		outputPage = Math.max(1, Math.ceil(x / pageWidth) + (curPage - 1));
	}
	return outputPage;
}



function openNotePanel(annID, createMode){
	//reportToDevice("alert", "annID = " + annID);
	if(typeof notePanel === 'undefined'){
		genNotePanel();
	} 
	if((showingNoteTextAnnID === annID) || (annID === -1)){
		try{
			//$(notePanel).hide();
			if(showingNoteTextAnnID >= 0){
				if(noteCache[showingNoteTextAnnID] != null){
					if(noteCache[showingNoteTextAnnID].length == 0){
						//如果文字為空，又是段落註記，則把此註記從annotationXML刪除，否則access不到
						for(var i = 0; i < annotationXML.childNodes[0].childNodes.length; i++){
							if(annotationXML.childNodes[0].childNodes[i].nodeName === "Annotation"){
								if(parseInt(annotationXML.childNodes[0].childNodes[i].getAttribute("annID")) === showingNoteTextAnnID){
									annNode = annotationXML.childNodes[0].childNodes[i];
									var startNodeId = "";
									var endNodeId = "";
									for(var j = 0; j < annNode.childNodes.length; j++){
										if(annNode.childNodes[j].nodeName == "Start"){
											startNodeId = annNode.childNodes[j].getAttribute("nodeID");
										}
										else if(annNode.childNodes[j].nodeName == "End"){
											endNodeId = annNode.childNodes[j].getAttribute("nodeID");
										}
									}
									if((startNodeId == endNodeId) && (startNodeId.length > 0)){
										annotationXML.childNodes[0].removeChild(annotationXML.childNodes[0].childNodes[i]);
										break;
									}
								}	
							}
						}
					}
				}
			}
			showingNoteTextAnnID = -1;
			
			reportToDevice("hideNote");
		}
		catch(e){
			reportToDevice("alert", e + "@openNotePanel");
		}
	}	
	else{
		//reportToDevice("alert", "step2.2");
		//$('#noteText').html(noteCache[annID]);
		
		var panelWidth = Math.round(Math.min(fullWidth * 0.45, fullHeight * 0.55));
		var panelHeight = Math.min(panelWidth, containerHeight);
		var panelLeft = Math.round((fullWidth - panelWidth) / 2) + bodyNode.scrollLeft;
		var panelTop = Math.round((fullHeight - panelHeight) / 2);
		
		
		document.getElementById("noteText").value = noteCache[annID];
		//$(notePanel).show();
		//$(notePanel).css('left', panelLeft + 'px');
		showingNoteTextAnnID = annID;		
		reportToDevice("updateAnnotation", "", 0, 0, "none", "none", "none", "none", "none", noteCache[annID], annID);
		hideHighlightPickerPanel();
		
		/*
		if(colorPickerPanelOpened){
			hideColorPickerPanel();
		}
		*/
	}
}

function hideNotePanel(){
	showingNoteTextAnnID = -1;
}

function hideColorPickerPanel(){
	if(typeof colorPickerPanel == 'undefined'){
		return true;
	}
	colorPickerPanel.style.display = "none";	
	colorPickerPanelOpened = false;	
	reportToDevice("displayTextSelector", false);
	
}

function hideHighlightPickerPanel(){
	if(typeof highlightPickerPanel == 'undefined'){
		return true;
	}
	highlightPickerPanel.style.visibility = "hidden";
	showNotePanel.style.visibility = "hidden";
	highlightPickerPanelOpened = false;
}



function showColorPickerPanel(targetObj, startIndex, endIndex, fontColor, bgColor, borderColor, textDecoration, fontWeight, updateAnnID){
	try{
		hideHighlightPickerPanel();
		if(colorPickerPanelOpened){
			return false;
		}
		var panelWidth = 380;
		var panelHeight = 380;
		var panelX = ((panelWidth <= fullWidth)?Math.round((fullWidth - panelWidth) / 2):0) + bodyNode.scrollLeft;
		if(typeof colorPickerPanel == 'undefined'){
			genColorPicker();
		}
		colorPickerPanel.style.left = panelX + "px";
		colorPickerPanel.style.display = "block";
		colorPickerPanelOpened = true;
		switchColorPickerFolder(0);
	}
	catch(e){
		reportToDevice("jsDebugInfo", "error@showColorPickerPanel():" + e);
	}
}


function genColorPicker(){
	var panelHTML = "";
	var colorValues = new Array();
	var panelWidth = 380;
	var panelHeight = 380;
	var panelLeft = 0;
	var panelTop = 0;
	var colorPickerIndex = 0;
	var bZoom = textSize;
	
	panelLeft = (panelWidth <= fullWidth)?Math.round((fullWidth - panelWidth) / 2):0;
	panelTop = (panelHeight <= fullHeight)?Math.round((fullHeight - panelHeight) / 2):0;
	for(var i = 0; i < 5; i++){
		colorValues[i] = new Array();
	}
	colorValues[0][0] = "none";
	colorValues[0][1] = "#000000";
	colorValues[0][2] = "#888888";
	colorValues[0][3] = "#FFFFFF";
	colorValues[1][0] = "#FF0000";
	colorValues[1][1] = "#FFA000";
	colorValues[1][2] = "#FFFF00";
	colorValues[1][3] = "#009000";
	colorValues[2][0] = "#FFA0A0";
	colorValues[2][1] = "#FFD0A0";
	colorValues[2][2] = "#FFFFA0";
	colorValues[2][3] = "#00FF00";
	colorValues[3][0] = "#00FFFF";
	colorValues[3][1] = "#0000D0";
	colorValues[3][2] = "#A000FF";
	colorValues[3][3] = "#FF00FF";
	colorValues[4][0] = "#B0FFFF";
	colorValues[4][1] = "#7090E0";
	colorValues[4][2] = "#D090FF";
	colorValues[4][3] = "#FF90FF";
	
	colorPickerPanel = document.createElement("div");
	colorPickerPanel.setAttribute("style", "position:absolute;left:" + panelLeft + "px;top:" + panelTop + "px;width:" + panelWidth + "px;height:" + panelHeight + "px;"
										+  "background-color:#F8F8F0;-webkit-box-shadow: 1px 1px 7px #000000;display:none;");
	colorPickerPanel.setAttribute("id", "colorPickerPanel");
	
	colorPickerLabel = document.createElement("div");
	colorPickerLabel.setAttribute("style", "position:absolute;left:0px;top:0px;width:" + panelWidth + "px;height:50px;z-index:4000;");
	colorPickerLabel.setAttribute("id", "colorPickerLabel");
	colorPickerPanel.appendChild(colorPickerLabel);
	
	try{
		//選取文字
		colorPickerFolder0 = document.createElement("div");
		colorPickerFolder0.setAttribute("style", "position:absolute;left:15px;top:65px;width:350px;height:250px;border:solid 1px #E0E0E0;z-index:4300;display:none;");
		colorPickerFolder0.setAttribute("id", "colorPickerFolder0");
		colorPickerFolder0.innerHTML = "folder 0";
		colorPickerPanel.appendChild(colorPickerFolder0);
		
		//樣式設定
		colorPickerFolder1 = document.createElement("div");
		colorPickerFolder1.setAttribute("style", "position:absolute;left:15px;top:65px;width:350px;height:250px;border:solid 1px #E0E0E0;z-index:4301;display:none;font-size:" + Math.ceil(14 * 100/ bZoom) + "pt;");
		colorPickerFolder1.setAttribute("id", "colorPickerFolder1");
		
		var paletteHTML = '<p style="line-height:' + Math.ceil(30 * 100 / bZoom) + 'px;font-size:' + Math.ceil(16 * 100/ bZoom) + 'pt;">';		
		paletteHTML += '<span id="btnBold" style="padding:3px 8px;margin-right:2px;border:solid 1px #C0C0C0;background:-webkit-gradient(linear, left top, left bottom, from(#F0F0F0), to(#D0D0D0));color:#666666;" value="0"  onclick="switchStyleEnabled(this)"><b>Ｂ</b>粗體</span>';
		paletteHTML += '<span id="btnUnderline" style="padding:3px 8px;border:solid 1px #C0C0C0;background:-webkit-gradient(linear, left top, left bottom, from(#F0F0F0), to(#D0D0D0));color:#666666;" value="0"  onclick="switchStyleEnabled(this)"><u>Ｕ</u>底線</span></p>';
		
		//enable時的底色-webkit-gradient(linear, left top, left bottom, from(#60C8D8), to(#5078E0))
		paletteHTML += '<div id="plLabel1" onclick="switchPalette(1)" style="position:absolute;z-index:3010;left:10px;top:50px;width:111px;height:26px;border:solid 1px #999999;padding:3px;border-right:none;background-color:#FFFFFF;">文字顏色';
		paletteHTML += '<div id="plIcon1" style="position:absolute;left:84px;top:4px;width:20px;height:20px;border:solid 1px #999999;background-color:#FF0000;"></div></div>';
		paletteHTML += '<div id="plLabel2" style="position:absolute;z-index:3009;left:10px;top:88px;width:110px;height:26px;border:solid 1px #999999;padding:3px;background-color:#E0E0E0;">背景顏色';
		paletteHTML += '<div id="plIcon2" style="position:absolute;left:84px;top:4px;width:20px;height:20px;border:solid 1px #999999;background-color:#FFFF00;"></div></div>';
		paletteHTML += '<div id="plLabel3" onclick="switchPalette(3)" style="position:absolute;z-index:3008;left:10px;top:126px;width:110px;height:26px;border:solid 1px #999999;padding:3px;background-color:#E0E0E0;">框線顏色';
		paletteHTML += '<div id="plIcon3" style="position:absolute;left:84px;top:4px;width:20px;height:20px;border:solid 1px #999999;text-align:center;color:#888888;background-color:#FFFFFF;">X</div></div>';
		
		paletteHTML += '<div style="position:absolute;z-index:3000;left:127px;top:50px;width:210px;height:150px;border:solid 1px #999999;">';
		
		
		
		
		for(var i = 0; i < colorValues.length; i++){
			for(var j = 0; j < colorValues[i].length; j++){
				var colorLabelNum = i + "" + j;
				if(colorValues[i][j] == "none"){
					paletteHTML += '<div id="colorLabel' + colorLabelNum + '" style="position:absolute;left:' + (i * 39 + 7) + 'px;top:' + (j * 35 + 4) + 'px;width:39px;height:35px;border:solid 1px #D0D0D0;background-color:#FFFFFF;color:#888888;font-size:' + Math.ceil(18 * 100 / bZoom) + 'pt;text-align:center;">X</div>';
				}
				else{
					paletteHTML += '<div id="colorLabel' + colorLabelNum + '" style="position:absolute;left:' + (i * 39 + 7) + 'px;top:' + (j * 35 + 4) + 'px;width:39px;height:35px;border:solid 1px #D0D0D0;background-color:' + colorValues[i][j] + ';"></div>';
				}
			}
		}
		
		
		paletteHTML += '</div>';
		colorPickerFolder1.innerHTML = paletteHTML;
		colorPickerPanel.appendChild(colorPickerFolder1);
		
		//輸入註記
		colorPickerFolder2 = document.createElement("div");
		colorPickerFolder2.setAttribute("style", "position:absolute;left:15px;top:65px;width:350px;height:250px;border:solid 1px #E0E0E0;z-index:4302;display:none;");
		colorPickerFolder2.setAttribute("id", "colorPickerFolder2");
		colorPickerFolder2.innerHTML = '<textarea id="txtNote" style="width:350px;height:250px;border:none;"></textarea>';
		colorPickerPanel.appendChild(colorPickerFolder2);
		
		//確定
		btnSaveAnnotation = document.createElement("button");
		btnSaveAnnotation.setAttribute("style", "position:absolute;left:15px;top:335px;width:170px;height:35px;font-size:" + Math.ceil(14 * 100/ bZoom) + "pt;");
		btnSaveAnnotation.innerHTML = "確定";
		btnSaveAnnotation.setAttribute("onclick", "hideColorPickerPanel()");
		colorPickerPanel.appendChild(btnSaveAnnotation);
		
		//取消
		btnCancelAnnotation = document.createElement("button");
		btnCancelAnnotation.setAttribute("style", "position:absolute;left:190px;top:335px;width:170px;height:35px;font-size:" + Math.ceil(14 * 100/ bZoom) + "pt;");
		btnCancelAnnotation.innerHTML = "取消";
		btnCancelAnnotation.setAttribute("onclick", "hideColorPickerPanel()");
		colorPickerPanel.appendChild(btnCancelAnnotation);
		
	}
	catch(e){
		reportToDevice("jsDebugInfo", "error@genColorPicker:" + e);
	}
	document.body.appendChild(colorPickerPanel);
	switchPalette(1);
	
	$("#plLabel2").click(function(){
		switchPalette(2);
	});
}

function switchPalette(index){
	var curChoosenColor;
	if(index == 1){
		curChoosenColor = ann_fontColor;
	}
	else if(index == 2){
		curChoosenColor = ann_bgColor;
	}
	else if(index == 3){
		curChoosenColor = ann_borderColor;
	}
	else{
		return false;
	}
	
	for(var i = 1; i <= 3; i++){
		if(i == index){
			document.getElementById("plLabel" + i).style.width = "111px";
			document.getElementById("plLabel" + i).style.backgroundColor = "#FFFFFF";
			document.getElementById("plLabel" + i).style.borderRight = "none";
		}
		else{
			document.getElementById("plLabel" + i).style.width = "110px";
			document.getElementById("plLabel" + i).style.backgroundColor = "#E0E0E0";
			document.getElementById("plLabel" + i).style.borderRight = "";
		}
	}

}


function switchStyleEnabled(btnObj){
	if(btnObj.getAttribute("value") == "1"){
		btnObj.setAttribute("value", "0");
		btnObj.style.background = "-webkit-gradient(linear, left top, left bottom, from(#F0F0F0), to(#D0D0D0))";
		btnObj.style.color = "#666666";
	}
	else{
		btnObj.setAttribute("value", "1");
		btnObj.style.background = "-webkit-gradient(linear, left top, left bottom, from(#60C8D8), to(#5078E0))";	
		btnObj.style.color = "#000000";
	}
}

function switchColorPickerFolder(index){
	var panelWidth = 380;
	var panelHeight = 380;
	var panelLeft = 0;
	var panelTop = 0;
	panelLeft = (panelWidth <= fullWidth)?Math.round((fullWidth - panelWidth) / 2):0;
	panelTop = (panelHeight <= fullHeight)?Math.round((fullHeight - panelHeight) / 2):0;
	
	drawColorPickerLabel(index);
	for(var i = 0; i < 3; i++){
		var curFolder = document.getElementById("colorPickerFolder" + i);
		curFolder.style.display = (i == index)?"block":"none";
	}
	if(index == 0){		
		reportToDevice("displayTextSelector", true, panelLeft + 15, panelTop + 65, 350, 250, "Test text, test text.\nLine 2");
	}
	else{
		reportToDevice("displayTextSelector", false);
	}
}

function drawColorPickerLabel(index){
	var bZoom = textSize;
	var labelHTML = "";
	var labelText = new Array("選取文字", "樣式設定", "輸入註記");
	for(var i = 0; i < 3; i++){
		labelHTML += '<div id="colorPickerLabel' + i + '" style="position:absolute;border:solid 1px #B0B0B0;top:0px;left:' + Math.round(380 * (i / 3)) + 'px;font-size:' + Math.ceil(14 * 100/ bZoom) + 'pt;width:126px;height:50px;text-align:center;line-height:' + Math.ceil(50 * 100/ bZoom) + 'px;';
		if(i == index){
			labelHTML += 'border-bottom:none;webkit-box-shadow: 1px 1px 5px #000000;background-color:#F8F8F0;z-index:' + (4200 + i) + ';';
		}
		else{
			labelHTML += 'background-color:#E0E0D8;z-index:' + (4100 + i) + ';';
		}
		labelHTML += '" >' + labelText[i] + '</div>';
	}
	document.getElementById("colorPickerLabel").innerHTML = labelHTML;
	$("#colorPickerLabel0").click(function(){	switchColorPickerFolder(0);});
	$("#colorPickerLabel1").click(function(){	switchColorPickerFolder(1);});
	$("#colorPickerLabel2").click(function(){	switchColorPickerFolder(2);});
}

function genHighlightPickerPanel(){
	var panelHTML = "";
	var colorValues = new Array();
	var bZoom = textSize;
	
	highlightPickerPanel = document.createElement("div");
	
	//colorPickerPanel.setAttribute("style", "position:absolute;left:" + ((fullWidth - 370) / 2) + "px;top:" + ((containerHeight - 290) / 2) + "px;width:400px;visibility:hidden;");

	highlightPickerPanel.setAttribute("id", "highlightPickerPanel");
	highlightPickerPanel.setAttribute("style", "position:absolute;left:0px;top:0px;width:230px;visibility:hidden;z-index:40000;");
	
	var HLPPBG = document.createElement("div");
	HLPPBG.setAttribute("style", 'position:absolute;left:0px;top:0px;width:223px;'
											+  'height:180px;text-align:left;-webkit-border-radius:8px;'
											+  '-webkit-box-shadow: 2px 2px 6px #000000;z-index:2000;'
											+  'background:-webkit-gradient(linear, left top, left bottom, from(#484848), to(#000000));'
											+  'padding:8px;padding-bottom:15px;color:#FFFFFF;font-size:' + Math.ceil(11 * 100/ bZoom) + 'pt');
	HLPPBG.setAttribute("id", "HLPPBG");
	highlightPickerPanel.appendChild(HLPPBG);
	
	var HLPPIndicator = document.createElement("div");
	HLPPIndicator.setAttribute("style", "position:absolute;z-index:1800;left:100px;top:197px;width:15px;height:15px;"
									+   "background-color:#000000;-webkit-transform:rotate(45deg);-webkit-box-shadow: 2px 2px 7px #000000;");
	HLPPIndicator.setAttribute("id", "HLPPIndicator");
	highlightPickerPanel.appendChild(HLPPIndicator);
	
	panelHTML = "";
	HLPPBG.innerHTML = panelHTML;	
	document.body.appendChild(highlightPickerPanel);
	
	
	showNotePanel = document.createElement("div");
	showNotePanel.setAttribute("style", 'position:absolute;left:3px;top:5px;width:170px;'
											+  'text-align:left;-webkit-border-radius:8px;'
											+  'z-index:2000;visibility:visible;'
											+  'background:-webkit-gradient(linear, left top, left bottom, from(#F0A0A0), to(#F0B0B0));'
											+  'padding:6px;padding-bottom:15px;color:#000000;font-size:' + Math.ceil(11 * 100/ bZoom) + 'pt');
	showNotePanel.setAttribute("id", "showNotePanel");

	
	
	noteIndicator = document.createElement("div");
	noteIndicator.setAttribute("style", "position:absolute;z-index:1900;left:-5px;top:20px;width:15px;height:15px;"
									+   "background-color:#F0A8A8;-webkit-transform:rotate(45deg);");
	noteIndicator.setAttribute("id", "noteIndicator");
	showNotePanel.appendChild(noteIndicator);
	
	noteTextContainer = document.createElement("div");
	noteTextContainer.setAttribute("style", "position:absolute;z-index:2200;left:3px;top:5px;width:170px;");
	showNotePanel.appendChild(noteTextContainer);
	
	
	document.body.appendChild(showNotePanel);
	//showNotePanel.innerHTML += showNotePanel.offsetHeight;
		
}


//大便利貼
function genNotePanel(){
	var bZoom = textSize;
	notePanel = document.createElement("div");
	var panelWidth = Math.round(Math.min(fullWidth * 0.45, fullHeight * 0.55));
	var panelHeight = Math.min(panelWidth, containerHeight);
	var panelLeft = Math.round((fullWidth - panelWidth) / 2) + bodyNode.scrollLeft;
	var panelTop = Math.round((fullHeight - panelHeight) / 2);
	
	notePanel.setAttribute("style", "position:absolute;left:" + panelLeft + "px;top:" + panelTop + "px;");	
	
	var bg1 = document.createElement("div");
	bg1.setAttribute("style", "position:absolute;left:0px;top:0px;z-index:30001;width:" + panelWidth + "px;height:" + Math.max(1, panelHeight - 40) + "px;"
							+ "background:-webkit-gradient(linear, left top, left bottom, from(#F0F0B0), to(#F0F0C0));"
							+ "-webkit-box-shadow: 0px 1px 5px #333333;");
							
	var bg2 = document.createElement("div");
	bg2.setAttribute("style", "position:absolute;left:0px;top:" + Math.max(1, panelHeight - 40) + "px;z-index:30000;width:" + panelWidth + "px;height:40px;"
							+ "background:-webkit-gradient(linear, left top, left bottom, from(#F0F0C0), to(#F0F0D6));"
							+ "-webkit-box-shadow: 0px 2px 6px #181818;");
							
	var bg3 = document.createElement("div");
	bg3.setAttribute("style", "position:absolute;left:0px;top:" + Math.max(1, panelHeight - 40) + "px;z-index:30005;width:" + panelWidth + "px;height:5px;"
							+ "background:-webkit-gradient(linear, left top, left bottom, from(#F0F0C0), to(#F0F0C0));");
	
	
	//右上角[確定] [關閉]
	var actionTextLine = document.createElement("div");
	actionTextLine.setAttribute("style", "position:absolute;left:10px;top:8px;width:" + (panelWidth - 20) + "px;"
								+   "font-size:" + Math.ceil(14 * 100 / bZoom) + "pt;z-index:30500;text-align:right;");								

	var okText = document.createElement("span");
	okText.setAttribute("style", "color:#3333E0;cursor:pointer;");
	okText.setAttribute("onclick", "saveNoteText();openNotePanel(-1);");
	okText.innerHTML = "[ 確定 ]";
	actionTextLine.appendChild(okText);
								
	var closeText = document.createElement("span");
	closeText.setAttribute("style", "color:#777777;cursor:pointer;margin-left:4px;");
	closeText.setAttribute("onclick", "openNotePanel(-1)");
	closeText.innerHTML = '[ 關閉 ]';
	actionTextLine.appendChild(closeText);
	
	
	var noteText = document.createElement("textarea");
	noteText.setAttribute("id", "noteText");
	noteText.setAttribute("cols" , "6");
	//noteText.setAttribute("onkeyup", "saveNoteText()");
	noteText.setAttribute("style", "position:absolute;left:10px;top:35px;width:" + (panelWidth - 20) + "px;heigth:" + (panelHeight - 45) + "px;"
								+  "overflow:auto;background-color:transparent;border:none;font-size:" + Math.ceil(14 * 100/ bZoom) + "pt;z-index:30100;");

								
	notePanel.appendChild(noteText);
	for(var i = 1; i <= 10; i++){		
		noteText.setAttribute("rows" , i);
		//reportToDevice("alert", noteText.offsetHeight);
		if($(noteText).height() >= (panelHeight - 45)){
			break;
		}
	}	
	
	var delText = document.createElement("div");
	delText.setAttribute("style", "position:absolute;left:10px;top:" + (panelHeight - 26) + "px;width:" + (panelWidth - 20) + "px;color:#E00000;cursor:pointer;"
								+   "font-size:" + Math.ceil(14 * 100 / bZoom) + "pt;z-index:30500;text-align:right;");
	delText.setAttribute("onclick", "delHighlight()");
	delText.innerHTML = '[ 刪除 ]';
	
	notePanel.appendChild(bg1);
	notePanel.appendChild(bg2);
	notePanel.appendChild(bg3);
	notePanel.appendChild(actionTextLine);
	bodyNode.appendChild(notePanel);
	notePanel.appendChild(delText);
	$(notePanel).hide();
	
}

function createNote(){	
	//reportToDevice("alert", "targetObj.id = " + targetObj.id);
	var annNodeID = "__ann" + (++annID);
	try{
		var realSelStart = getRealPos(highlightingNode, 0, 0);
		var realSelEnd = getRealPos(highlightingNode, 0, 0);
		var styleObj = new Object();
		styleObj.borderColor = "none";
		highlight(annNodeID, realSelStart.node, realSelStart.offset, realSelEnd.node, realSelEnd.offset, styleObj);
		addAnnotationNode(highlightingNode.id, 0, highlightingNode.id, 0, -1, "");
		noteCache[annID] = "";
		//openNotePanel(annID);
		reportToDevice("updateAnnotation", "", 0, 0, "none", "none", "none", "none", "none", "", annID);
		hideHighlightPickerPanel();
		
	}
	catch(e){
		reportToDevice("jsDebugInfo", "error in createNote():" + e);
	}
	analyzeHighlightPositions();
}


function getRealPos(node, offset, targetOffset){
	returnObj = new Object();
	var lowerNodeName = node.nodeName.toLowerCase();
	if(lowerNodeName == "#text"){
		if(offset + node.nodeValue.length >= targetOffset){	//要找的目標在此
			returnObj.node = node;
			returnObj.offset = targetOffset - offset;
		}
		else{
			returnObj.node = null;
			returnObj.nodeLength = node.nodeValue.length;
		}
		return returnObj;
	}
	else if(lowerNodeName == "br"){
		returnObj.node = null;
		returnObj.nodeLength = 1;
		return returnObj;
	}
	else{
		var myLength = 0;
		for(var i = 0; i < node.childNodes.length; i++){
			var resultObj = getRealPos(node.childNodes[i], offset, targetOffset);
			if(resultObj.node != null){
				return resultObj;
			}
			else{
				offset += resultObj.nodeLength;
				myLength += resultObj.nodeLength;
			}
		}
		returnObj.node = null;
		returnObj.nodeLength = myLength;
		return returnObj;
	}
}

function constructAnnotation(annXML, specific_id){
	var startNode;
	var endNode;
	var startOffset;
	var endOffset;
	var styleObj = new Object();
	var skipType = 0;
	
	annotations = annXML.getElementsByTagName("Annotation");
	for(var i = 0; i < annotations.length; i++){
		var tmpAnnID = parseInt(annotations[i].getAttribute("annID"));
		annID = Math.max(tmpAnnID, annID);
		var curAnnID = "__ann" + tmpAnnID;
		var stNode = new Object();
		var edNode = new Object();
		var skip = false;
		for(var j = 0; j < annotations[i].childNodes.length; j++){
			var annDetailNode = annotations[i].childNodes[j];
			var annDetailNodeName = annDetailNode.nodeName;
			if(annDetailNodeName === "Start"){
				st = annDetailNode;
				if(specific_id != null){
					if(specific_id != st.getAttribute("nodeID")){
						skip = true;
						skipType = 5;
						continue;
					}
				}
				startNode = document.getElementById(st.getAttribute("nodeID"));				
				if(startNode == null){
					j = annotations[i].childNodes.length;
					skip = true;
					skipType = 1;
					continue;
				}
				try{
					startOffset = st.getAttribute("offset");
					//alert('startNode(' + startNode.getAttribute("id") + ').getAttribute("cutoffset") = ' + startNode.getAttribute("cutOffset"));
				}
				catch(e){
					reportToDevice("alert", "E(4):" + e);
				}
				//alert("stNode = getDOMPos(" + startNode.nodeName + ", " + startOffset + ")");
				stNode = getDOMPos(startNode, startOffset);
				if(stNode.node == null){
					j = annotations[i].childNodes.length;
					skip = true;
					skipType = 2;
					continue;
				}
			}
			else if(annDetailNodeName === "End"){
				ed = annDetailNode;
				endNode = document.getElementById(ed.getAttribute("nodeID"));
				if(endNode == null){
					j = annotations[i].childNodes.length;					
					skip = true;
					skipType = 3;
					continue;
				}
				endOffset = ed.getAttribute("offset");
				if(endNode.getAttribute("cutOffset") != null){
					endOffset -= endNode.getAttribute("cutOffset");
				}
				edNode = getDOMPos(endNode, endOffset);				
				if(edNode.node == null){
					if(edNode.offset > 0){
						edNode = getDOMPos(endNode, edNode.offset);
						if(edNode.node == null){
							j = annotations[i].childNodes.length;
							skip = true;
							skipType = 4;
							continue;
						}
					}
				}
			}
			else if(annDetailNodeName === "ShowType"){
				var showType = annDetailNode.getAttribute("type");
				if(showType === "highlight"){
					styleObj.fontColor = annDetailNode.getAttribute("foregroundColor");
					styleObj.bgColor = annDetailNode.getAttribute("backgroundColor");
				}
				else if(showType === "border"){
					styleObj.borderColor = annDetailNode.getAttribute("borderColor");
				}
				else if(showType === "textDecoration"){
					styleObj.textDecoration = annDetailNode.getAttribute("lineType");
				}
				else if(showType === "fontWeight"){
					styleObj.fontWeight = annDetailNode.getAttribute("weight");
				}
			}
			
			else if(annDetailNodeName === "AttachedText"){
				if(annDetailNode.childNodes[0] != null){
					if(annDetailNode.childNodes[0].nodeName.toLowerCase() === "#text"){
						attachedText = annDetailNode.childNodes[0].nodeValue;
						noteCache[tmpAnnID] = attachedText;
					}
				}
			}
			
		}
		if(!skip){
			if(startNode.getAttribute("oriHTML") == null){
				startNode.setAttribute("oriHTML", startNode.innerHTML);
			}
			try{
				highlight(curAnnID, stNode.node, stNode.offset, edNode.node, edNode.offset, styleObj);
			}
			catch(e){
				reportToDevice("jsDebugInfo", "Exception @142:" + e);
			}
		}
	}
	analyzeHighlightPositions();
}


function highlight(annNodeID, startNode, startOffset, endNode, endOffset, specifiedStyle){
	if(startNode == endNode){
		var oriParentNode = startNode.parentNode;
		ancrOffset = Math.max(0, startOffset);
		fcsOffset = Math.max(0, endOffset);
		//var ancrOffset = Math.min(startOffset, endOffset);
		//var fcsOffset = Math.max(startOffset, endOffset);
		newChildNodesSet = new Array();
		var appendedChild = 0;
		for(var i = 0; i < oriParentNode.childNodes.length; i++){
			if(oriParentNode.childNodes[i] == startNode){
				//選取區前文字
				var newTextNode = document.createTextNode(startNode.nodeValue.substring(0, ancrOffset));
				newChildNodesSet[appendedChild++] = newTextNode;
				//選取區本身放在一個span node裡
				newTextNode = document.createTextNode(startNode.nodeValue.substring(ancrOffset, fcsOffset));
				var newSpan = document.createElement("span");
				newSpan.appendChild(newTextNode);
				newSpan.setAttribute("annID", annNodeID);
				
				createAnnotationObj(newSpan, 'highlight', 'full', specifiedStyle);
				
				newChildNodesSet[appendedChild++] = newSpan;
				//選取區後文字
				newTextNode = document.createTextNode(startNode.nodeValue.substring(fcsOffset));
				newChildNodesSet[appendedChild++] = newTextNode;
			}
			else{
				newChildNodesSet[appendedChild++] = startNode.parentNode.childNodes[i];
			}
		}
		oriParentNode.innerHTML = "";
		for(var i = 0; i < newChildNodesSet.length; i++){
			oriParentNode.appendChild(newChildNodesSet[i]);
		}
		//alert(newSpan.offsetTop);
		//addAnnSymbol(annNodeID, newSpan.offsetTop, newSpan.offsetLeft);
		
	}
	else{		
		var commonNode = findCommonNode(startNode, endNode);
		if(commonNode == mainContainer){	//僅限原本在同一個text node的範圍內選取
			return false;
		}
		startNodeTraced = false;
		endNodeTraced = false;
		startCutOffset = 0;
		endCutOffset = 0;
		traceAndAddAnotation(annNodeID, commonNode, startNode, endNode, startOffset, endOffset, specifiedStyle);
	}
}

function traceAndAddAnotation(annNodeID, curNode, startNode, endNode, startOffset, endOffset, specifiedStyle){
	var startSpan;
	var newSpan;
	//var annNodeID = "__ann" + annID;
    
	if(curNode == startNode){
		var oriParentNode = curNode.parentNode;
		newChildNodesSet = new Array();
		var appendedChild = 0;
		for(var i = 0; i < oriParentNode.childNodes.length; i++){
			if(oriParentNode.childNodes[i] == curNode){
				//選取區前文字
				var newTextNode = document.createTextNode(curNode.nodeValue.substring(0, startOffset));
				newChildNodesSet[appendedChild++] = newTextNode;
				//選取區本身放在一個span node裡
				newTextNode = document.createTextNode(curNode.nodeValue.substring(startOffset));
				startSpan = document.createElement("span");
				startSpan.appendChild(newTextNode);
				startSpan.setAttribute("annID", annNodeID);
				createAnnotationObj(startSpan, 'highlight', 'start', specifiedStyle);
				newChildNodesSet[appendedChild++] = startSpan;
			}
			else{
				newChildNodesSet[appendedChild++] = curNode.parentNode.childNodes[i];
			}
		}
		oriParentNode.innerHTML = "";
		for(var i = 0; i < newChildNodesSet.length; i++){
			oriParentNode.appendChild(newChildNodesSet[i]);
		}
		
		//addAnnSymbol(annNodeID, startSpan.offsetTop, startSpan.offsetLeft);
		startNodeTraced = true;
	}
	else if(curNode == endNode){
		if(!startNodeTraced){	//起始node都還沒找到就找到結束node，代表反著選，直接取消
			return false;
		}
		var oriParentNode = curNode.parentNode;
		newChildNodesSet = new Array();
		var appendedChild = 0;
		for(var i = 0; i < oriParentNode.childNodes.length; i++){
			if(oriParentNode.childNodes[i] == curNode){
				//選取區本身放在一個span node裡
				newTextNode = document.createTextNode(curNode.nodeValue.substring(0, endOffset));
				newSpan = document.createElement("span");
				newSpan.setAttribute("annID", annNodeID);
				createAnnotationObj(newSpan, 'highlight', 'end', specifiedStyle);
				newSpan.appendChild(newTextNode);
				newChildNodesSet[appendedChild++] = newSpan;
				//選取區後文字
				newTextNode = document.createTextNode(curNode.nodeValue.substring(endOffset));
				newChildNodesSet[appendedChild++] = newTextNode;
			}
			else{
				newChildNodesSet[appendedChild++] = curNode.parentNode.childNodes[i];
			}
		}
		oriParentNode.innerHTML = "";
		for(var i = 0; i < newChildNodesSet.length; i++){
			oriParentNode.appendChild(newChildNodesSet[i]);
		}
		endNodeTraced = true;
		return true;
	}
	else if(	(startNodeTraced && !(endNodeTraced))
            &&	(curNode.nodeName == "#text")			){
        //已經經過startNode，本node全選		
		if(curNode.nodeName == "#text"){
			if(curNode.parentNode.getAttribute("annID") != "__ann" + annID){
				var oriParentNode = curNode.parentNode;
				newChildNodesSet = new Array();
				var appendedChild = 0;
				for(var i = 0; i < oriParentNode.childNodes.length; i++){
					if(oriParentNode.childNodes[i] == curNode){
						//選取區本身放在一個span node裡
						newTextNode = document.createTextNode(curNode.nodeValue);
						newSpan = document.createElement("span");
						newSpan.setAttribute("annID", annNodeID);
						createAnnotationObj(newSpan, 'highlight', 'middle', specifiedStyle);
						newSpan.appendChild(newTextNode);
						newChildNodesSet[appendedChild++] = newSpan;
					}
					else{
						newChildNodesSet[appendedChild++] = curNode.parentNode.childNodes[i];
					}
				}
				oriParentNode.innerHTML = "";
				for(var i = 0; i < newChildNodesSet.length; i++){
					oriParentNode.appendChild(newChildNodesSet[i]);
				}
				//createAnnotationObj(curNode.parentNode, 'highlight', 'middle');
			}
		}
	}
	else if(curNode.nodeName != "#text"){
		for(var i = 0; i < curNode.childNodes.length; i++){
			traceAndAddAnotation(annNodeID, curNode.childNodes[i], startNode, endNode, startOffset, endOffset, specifiedStyle);
		}
	}
}

function createAnnotationObj(obj, annotationType, posType, specifiedStyle){			
	//posType代表是在選取區的那部分，第一個node為start，最後一個為end，其餘為middle。這是為了讓有框線的highlight不會因為跨node而看起來切成多段
	var my_bgColor = ann_bgColor;
	var my_fontColor = ann_fontColor;
	var my_borderColor = ann_borderColor;
	var my_textDecoration = ann_textDecoration;
	var my_fontWeight = ann_fontWeight;
	if(specifiedStyle != null){
		my_bgColor = (specifiedStyle.bgColor!=null)?specifiedStyle.bgColor:ann_bgColor;
		my_fontColor = (specifiedStyle.fontColor!=null)?specifiedStyle.fontColor:ann_fontColor;
		my_borderColor = (specifiedStyle.borderColor!=null)?specifiedStyle.borderColor:ann_borderColor;
		my_textDecoration = (specifiedStyle.textDecoration!=null)?specifiedStyle.textDecoration:ann_textDecoration;
		my_fontWeight = (specifiedStyle.fontWeight!=null)?specifiedStyle.fontWeight:ann_textDecoration;
	}
	
	
	if(annotationType == 'highlight'){
		obj.style.backgroundColor = ((my_bgColor.length > 0)?my_bgColor:"none");
		if(my_fontColor.length > 0){
			obj.style.color = my_fontColor;
		}
		obj.style.border = ((my_borderColor.length > 0)?("solid 1pt " + my_borderColor):"none");
		obj.setAttribute("borderColor", my_borderColor);
		if(posType == 'middle'){
			obj.style.borderLeft = "none";
			obj.style.borderRight = "none";
		}	
		else if(posType == 'start'){
			obj.style.borderRight = "none";
		}
		else if(posType == 'end'){
			obj.style.borderLeft = "none";
		}
		obj.style.paddingRight = "-1px";
		//else if(posType == 'full'){	//還有一個case是posType == 'full'，但不用做任何動作
		//	keep borders
		//}
		obj.style.marginBottom = "-1px";
		obj.style.textDecoration = my_textDecoration;
		obj.style.fontWeight = (my_fontWeight == "none")?"normal":my_fontWeight;
		obj.style.cursor = "pointer";
		
		obj.setAttribute("onclick", "showMyAnnID(this)");
		obj.setAttribute("onMouseOver", "overSymbol('" + obj.getAttribute("annID") + "')");
		obj.setAttribute("onMouseOut", "outSymbol('" + obj.getAttribute("annID") + "')");
	}
}

function showMyAnnID(obj){
	if(tracingAnnID == false){
		tracingAnnID = true;
		tracedAnnID = new Array();
		tracedAnnID[0] = obj.getAttribute("annID");
	}
	else{
		var addingAnnID = obj.getAttribute("annID");
		for(var i = 0; i < tracedAnnID.length; i++){
			if(tracedAnnID[i] == addingAnnID){
				return false;
			}
		}
		tracedAnnID[tracedAnnID.length] = addingAnnID;
	}
}


function delHighlight(updateAnnID){
	var delFromNoteText = false;
	if(typeof updateAnnID == 'undefined'){
		if(showingNoteTextAnnID >= 0){
			updateAnnID = showingNoteTextAnnID;
			delFromNoteText = true;
		}
		else{
			return false;
		}
	}
	noteCache[updateAnnID] = "";
	for(var i = 0; i < annotationXML.childNodes[0].childNodes.length; i++){
		if(annotationXML.childNodes[0].childNodes[i].nodeName == "Annotation"){
			if(parseInt(annotationXML.childNodes[0].childNodes[i].getAttribute("annID")) == updateAnnID){				
				if(delFromNoteText){
					var curAnnNode = annotationXML.childNodes[0].childNodes[i];
					for(var j = 0; j < curAnnNode.childNodes.length; j++){
						if(curAnnNode.childNodes[j].nodeName.toLowerCase() == "start"){
							var curAnnNodeID = curAnnNode.childNodes[j].getAttribute("nodeID");
							highlightingNode = document.getElementById(curAnnNodeID);
							break;
						}
					}
				}
				annotationXML.childNodes[0].removeChild(annotationXML.childNodes[0].childNodes[i]);
				break;
			}	
		}
	}
	if(highlightingNode != null){
		if(highlightingNode.getAttribute("oriHTML") != null){
			highlightingNode.innerHTML = highlightingNode.getAttribute("oriHTML");
		}
		constructAnnotation(annotationXML, highlightingNode.id);
	}
	
	try{
		reportToDevice("reportAnnotation", xmlToStr(annotationXML.firstChild));
		hideHighlightPickerPanel();
		hideColorPickerPanel();
		openNotePanel(-1);
		analyzeHighlightPositions();
	}
	catch(e){
		reportToDevice("jsDebugInfo", "error in delHighlight():" + e);
	}
}

function addHighlightByOuterUI(startIndex, endIndex, fontWeight, textDecoration, fontColor, bgColor, borderColor, noteText, updateAnnID){	
	textSelectionPanelOpened = false;
	
	if(startIndex != 0 || endIndex != 0){
		if(typeof fontWeight != 'undefied')	ann_fontWeight = fontWeight;
		if(typeof textDecoration != 'undefied')	ann_textDecoration = textDecoration;
		if(typeof fontColor != 'undefied')	ann_fontColor = ARGBtoRGB(fontColor);
		if(typeof bgColor != 'undefied')	ann_bgColor = ARGBtoRGB(bgColor);
		if(typeof borderColor != 'undefied')	ann_borderColor = ARGBtoRGB(borderColor);
	}
	
    //alert("annotatingObj = " + annotatingObj + ", highlightingNode = " + highlightingNode);
	var realSelStart = getRealPos(highlightingNode, 0, startIndex);
	var realSelEnd = getRealPos(highlightingNode, 0, endIndex);
    colorPickerPanelOpened = false;
    
	
	try{
		if(updateAnnID == null){
			annNodeID = "__ann" + (++annID);
			if(highlightingNode.getAttribute("oriHTML") == null){
				highlightingNode.setAttribute("oriHTML", highlightingNode.innerHTML);
			}
			highlight(annNodeID, realSelStart.node, realSelStart.offset, realSelEnd.node, realSelEnd.offset);
			addAnnotationNode(highlightingNode.id, startIndex, highlightingNode.id, endIndex, null, noteText);
			noteCache[annID] = noteText;
			analyzeHighlightPositions();
		}
		else{
			addAnnotationNode(highlightingNode.id, startIndex, highlightingNode.id, endIndex, updateAnnID, noteText);
			setTimeout("delayRedrawHighlight()", 100);
		}
	}
	catch(e){
		reportToDevice("jsDebugInfo", "error@addHighlightByOuterUI:" + e);
	}
}


function findCommonNode(startNode, endNode){
	//alert('findCommonNode(' + startNode + ", " + endNode + ")");
	var commonNode;
	var oriAncrParentNode = startNode;
	var anchorIndexOffset = 0;
	var focusIndexOffset = 0;
	while(oriAncrParentNode != mainContainer){
		if(oriAncrParentNode.id != null){
			if(oriAncrParentNode.id.indexOf("__node") == 0){
				break;
			}
		}
		oriAncrParentNode = oriAncrParentNode.parentNode;
		anchorIndexOffset++;
	}
	var startNodeId = oriAncrParentNode.id;
	
	var oriFcsParentNode = endNode;
	while(oriFcsParentNode != mainContainer){
		if(oriFcsParentNode.id != null){
			if(oriFcsParentNode.id.indexOf("__node") == 0){
				break;
			}
		}
		oriFcsParentNode = oriFcsParentNode.parentNode;
		focusIndexOffset++;
	}
	var endNodeId = oriFcsParentNode.id;	
	
	if(startNodeId == endNodeId){
		return document.getElementById(startNodeId);
	}
	else{
		return mainContainer;
	}
	
}

function delayRedrawHighlight(){
    if(highlightingNode.getAttribute("oriHTML") != null){
        var oriHTML = highlightingNode.getAttribute("oriHTML");
        highlightingNode.innerHTML = oriHTML;
    }
    constructAnnotation(annotationXML, highlightingNode.id);
    analyzeHighlightPositions();
    reportToDevice("reportAnnotation", xmlToStr(annotationXML.firstChild));
}


function initializeXML(){	
	if(typeof annotationXMLStr == 'undefined' || annotationXMLStr.length == 0){
		//annotationXML = createXMLDocument('<Book DOI="" fileID="" userID="" format="epub"></Book>');	
		annotationXML = createXMLDocument('<NodeAnnotation itemID="" userID=""></NodeAnnotation>');
		
	}
	else{
	
		annotationXML = createXMLDocument(annotationXMLStr);
		//reportToDevice("alert", "annotationXMLStr = " + annotationXMLStr);
		try{		
			constructAnnotation(annotationXML);
		}
		catch(e){
			reportToDevice("jsDebugInfo", "E(3):" + e);
		}
	}
	
	initializeUserSetting();
}

//在annotationXML新增或更新標註內容
function addAnnotationNode(startNodeId, startOffset, endNodeId, endOffset, updateAnnID, noteText){
	var highlightedText = "";
	if(document.getElementById(startNodeId) != null){
		var highlightedText = getAllTextOfANode(document.getElementById(startNodeId)).substring(startOffset, endOffset);
	}
	var annNode;
	if((updateAnnID == null) || (typeof updateAnnID == 'undefined')){	//新增模式	
		annNode = annotationXML.createElement("Annotation");
		annNode.setAttribute("annID", annID);
	}
	else if(updateAnnID === -1){ //僅新增註記
		annNode = annotationXML.createElement("Annotation");
		annNode.setAttribute("annID", annID);
	}
	else{	//編輯模式
		for(var i = annotationXML.childNodes[0].childNodes.length - 1; i >= 0; i--){
			if(annotationXML.childNodes[0].childNodes[i].nodeName === "Annotation"){				
				if(parseInt(annotationXML.childNodes[0].childNodes[i].getAttribute("annID")) === updateAnnID){
					//是本來要編輯的node，把底下所有屬性node全刪掉
					annNode = annotationXML.childNodes[0].childNodes[i];
					for(var j = annNode.childNodes.length - 1; j >= 0; j--){
						annNode.removeChild(annNode.childNodes[j]);
					}
				}
				else{
					//不是本來要編輯的node，找看看是不是有段落註記（start和End都同一位置）且沒有附加任何文字，則把它刪除
					var checkingAnnNode = annotationXML.childNodes[0].childNodes[i];
					var tmpStartNodeID = tmpEndNodeID = "";
					var tmpStartOffset = tmpEndOffset = 0;
					var attrFound = false;
					var haveAttachedText = false;
					for(var j = 0; j < checkingAnnNode.childNodes.length; j++){
						if(checkingAnnNode.childNodes[j].nodeName == "Start"){
							tmpStartNodeID = checkingAnnNode.childNodes[j].getAttribute("nodeID");
							tmpStartOffset = parseInt(checkingAnnNode.childNodes[j].getAttribute("offset"));
							attrFound = true;
						}
						else if(checkingAnnNode.childNodes[j].nodeName == "End"){
							tmpEndNodeID = checkingAnnNode.childNodes[j].getAttribute("nodeID");
							tmpEndOffset = parseInt(checkingAnnNode.childNodes[j].getAttribute("offset"));
						}
						else if(checkingAnnNode.childNodes[j].nodeName == "AttachedText"){
							if(checkingAnnNode.childNodes[j].childNodes.length > 0){
								if(checkingAnnNode.childNodes[j].childNodes[0].nodeName.toLowerCase() == "#text"){
									if(checkingAnnNode.childNodes[j].childNodes[0].nodeValue.length > 0){
										haveAttachedText = true;
									}
								}
							}
						}
					}
					if(!haveAttachedText && attrFound && (tmpStartNodeID == tmpEndNodeID) && (tmpStartOffset == tmpEndOffset)){
						reportToDevice("jsDebugInfo", "removed " + checkingAnnNode.getAttribute("annID"));
						checkingAnnNode.parentNode.removeChild(checkingAnnNode);
					}
				}
			}
		}	
	}
	
	//<Start nodeID="" offset="" x="" y=""/>
	var posNode = annotationXML.createElement("Start");
	posNode.setAttribute("nodeID", startNodeId);
	posNode.setAttribute("offset", startOffset);
	annNode.appendChild(posNode);
	
	//<End nodeID="" offset="" x="" y=""/>
	posNode = annotationXML.createElement("End");
	posNode.setAttribute("nodeID", endNodeId);
	posNode.setAttribute("offset", endOffset);
	annNode.appendChild(posNode);
	
	//<ShowType type="highlight" foregroundcolor="" backgroundcolor=""/>
	var showTypeNode = annotationXML.createElement("ShowType");
	showTypeNode.setAttribute("type", "highlight");
	showTypeNode.setAttribute("foregroundColor", ann_fontColor);
	showTypeNode.setAttribute("backgroundColor", ann_bgColor);
	annNode.appendChild(showTypeNode);
	
	//<ShowType type="border" bordercolor="" borderSize="" borderType="solid|...."/>
	var showTypeNode = annotationXML.createElement("ShowType");
	showTypeNode.setAttribute("type", "border");
	showTypeNode.setAttribute("borderColor", ann_borderColor);
	annNode.appendChild(showTypeNode);
	
	//<ShowType type="textDecoration" lineType="underline|line-through|overline|none"/>
	var showTypeNode = annotationXML.createElement("ShowType");
	showTypeNode.setAttribute("type", "textDecoration");
	showTypeNode.setAttribute("lineType", ann_textDecoration);
	annNode.appendChild(showTypeNode);
	
	//<ShowType type="fontWeight" weight="bold|none"/>
	var showTypeNode = annotationXML.createElement("ShowType");
	showTypeNode.setAttribute("type", "fontWeight");
	showTypeNode.setAttribute("weight", ann_fontWeight);
	annNode.appendChild(showTypeNode);
	
	
	//<HighlightedText> bla bla bla... </HighlightedText>
	var highlightedTextNode = annotationXML.createElement("HighlightedText");
	var HLText = annotationXML.createTextNode(highlightedText);
	highlightedTextNode.appendChild(HLText);
	annNode.appendChild(highlightedTextNode);
	
	//<AttachedText> bla bla bla....</AttachedText>
	var attachedTextNode = annotationXML.createElement("AttachedText");	
	if(typeof noteText != 'undefined'){
		var innerTextNode = annotationXML.createTextNode(noteText);
		attachedTextNode.appendChild(innerTextNode);
		annNode.appendChild(attachedTextNode);	
	}
	else{
		var NC = document.getElementById("noteContainer");
		var attachedText = "";
		if(NC != null){
			attachedText = NC.value;
		}
		//待處理:將\n換成HTML專用斷行字元
		var innerTextNode = annotationXML.createTextNode(attachedText);
		attachedTextNode.appendChild(innerTextNode);
		annNode.appendChild(attachedTextNode);
	}
	
	if(updateAnnID == null){   
		annotationXML.childNodes[0].appendChild(annNode);
		noteCache[annID] = attachedText;
	}
	else if(updateAnnID === -1){
		annotationXML.childNodes[0].appendChild(annNode);
		noteCache[annID] = attachedText;	
	}
	else{
		noteCache[updateAnnID] = attachedText;
	}
	
	//reportToDevice("alert", xmlToStr(annotationXML.firstChild));
	reportToDevice("reportAnnotation", xmlToStr(annotationXML.firstChild));
	//alert(xmlToStr(annotationXML, ''));
	
}

function getDOMPos(curNode, offset){
	//alert('getDOMPos(curNode, ' + offset + ')');
	var posObj = new Object();
	posObj.node = null;
	posObj.offset = 0;
	if(curNode.nodeName === "#text"){
		if(curNode.nodeValue.length >= offset){
			posObj.node = curNode;
			posObj.offset = offset;
			return posObj;
		}
		else{
			posObj.offset = curNode.nodeValue.length;
			return posObj;
		}
	}
	else{
		var tracedChildTextLength = 0;
		if(curNode.childNodes.length > 0){
			for(var i = 0; i < curNode.childNodes.length; i++){
				/*
				if(curNode.getAttribute("cutoffset") != null){
					tracedChildTextLength += parseInt(curNode.getAttribute("cutoffset"), 10);
				}
				*/
				var childPosObj = getDOMPos(curNode.childNodes[i], offset - tracedChildTextLength);
				if(childPosObj.node != null){
					return childPosObj;
				}
				else{
					tracedChildTextLength += childPosObj.offset;
				}
			}
			posObj.offset = tracedChildTextLength;
			return posObj;
		}
		else{
			//posObj.offset = 0;
			posObj.offset = tracedChildTextLength;
			return posObj;
		}
	}
}



function saveNoteText(){
	if(showingNoteTextAnnID === -1){
		return true;
	}
	var updateAnnID = showingNoteTextAnnID;
	var newNoteText = noteText.value;
	var annXML = annotationXML;
	
	annotations = annXML.getElementsByTagName("Annotation");
	
	for(var i = annotations.length - 1; i >= 0; i--){
		var tmpAnnID = parseInt(annotations[i].getAttribute("annID"));
		if(updateAnnID == tmpAnnID){
			if(newNoteText.length == 0){		//沒輸入文字或刪光了，就刪除本段落註記
				noteCache[updateAnnID] = "";				
				annotations[i].parentNode.removeChild(annotations[i]);
			}
			else{
				for(var j = 0; j < annotations[i].childNodes.length; j++){
					var annDetailNode = annotations[i].childNodes[j];
					var annDetailNodeName = annDetailNode.nodeName;				
					if(annDetailNodeName === "AttachedText"){
						annDetailNode.innerText = newNoteText;
						noteCache[updateAnnID] = newNoteText;
						
						var shouldClearChildren = false;
						if(annDetailNode.hasChildNodes()){
							if (annDetailNode.childNodes[0].nodeName.toLowerCase() === "#text"){
								annDetailNode.childNodes[0].nodeValue = newNoteText;
								noteCache[tmpAnnID] = newNoteText;
							}
							else{
								shouldClearChildren = true;
							}
						}
						else{
							shouldClearChildren = true;
						}
						
						if(shouldClearChildren){
							while(annDetailNode.childNodes.length >= 1){
								annDetailNode.removeChild(annDetailNode.firstChild);
							}
							var tmpTextNode = annXML.createTextNode(newNoteText);
							annDetailNode.appendChild(tmpTextNode);
							
						}
						
					}				
				}
			}
			break;
		}
	}
	reportToDevice("reportAnnotation", xmlToStr(annotationXML.firstChild));
	analyzeHighlightPositions();
}


function initializeUserSetting(){
	if(typeof userSettingXMLStr == 'undefined'){
		userSettingXML = createXMLDocument('<userSetting userID=""><Annotation></Annotation></userSetting>');
	}
	else{
		userSettingXML = createXMLDocument(userSettingXMLStr);	
		var rootNode = userSettingXML.firstChild;
		for(var n = 0 ; n < rootNode.childNodes.length; n++){
			if(rootNode.childNodes[n].nodeName == "Annotation"){
				var attributeCount = rootNode.childNodes[n].attributes.length;
				for(var i = 0; i < attributeCount; i++){
					var tmpAttr = rootNode.childNodes[n].attributes[i];
					if(tmpAttr.name == "bgColor"){
						ann_bgColor = tmpAttr.value;
					}
					else if(tmpAttr.name == "borderColor"){
						ann_borderColor = tmpAttr.value;
					}
					else if(tmpAttr.name == "fontColor"){
						ann_fontColor = tmpAttr.value;
					}
					else if(tmpAttr.name == "textDecoration"){
						ann_textDecoration = tmpAttr.value;
					}
					else if(tmpAttr.name == "fontWeight"){
						ann_fontWeight = tmpAttr.value;
					}
				}
				break;
			}
		}
	}
}



function getAllTextOfANode(node){
	var text = "";
	for(var i = 0; i < node.childNodes.length; i++){
		var childLowerNodeName = node.childNodes[i].nodeName.toLowerCase();
		if(childLowerNodeName == "#text"){
			text += node.childNodes[i].nodeValue;
		}
		else if(childLowerNodeName == "br"){
			text += "\n";
		}
		else{
			text += getAllTextOfANode(node.childNodes[i]);
		}
	}
	return text;
}

function RGBtoARGB(colorCode){
	if(colorCode == "none"){
		return "#00000000";
	}
	else if((colorCode.length == 7) && (colorCode.substring(0, 1) == "#")){
		return "#FF" + colorCode.substring(1);
	}
	return colorCode;
}

function ARGBtoRGB(colorCode){
	if(colorCode.length == 9){
		if(colorCode.substring(0, 3) == "#00"){
			return "none";
		}
		else{
			return "#" + colorCode.substring(3);
		}
	}
	else{
		return colorCode;
	}
}


/************************************
  Search相關
  ***********************************/
var foundRects = new Array();  
var targetIndex = -1;
var foundSerialNo = 0;
var pageWidth = 0;

function jumpToSearchedIndex(searchWord, wordIndex, jumpPage){
	
	pageWidth = containerWidth + paddingLeft + paddingRight;
	targetIndex = wordIndex;
	reportToDevice("jsDebugInfo", "jump to " + wordIndex + "th " + searchWord);
	targetIndex = wordIndex;
	searchKeyword(searchWord);
	foundRects.sort(sortByPosition);
	var prevNo = -1;
	var foundIndex = -1;
	var targetPage = 0;
	var foundRectsCount = foundRects.length;
	var leftOffset = parseInt(document.body.scrollLeft);
	
	$(".searchResult").remove();
	for(var i = 0; i < foundRectsCount; i++){
		if(prevNo != foundRects[i].serialNo){
			foundIndex++;	
		}
		foundRects[i].foundIndex = foundIndex;
		prevNo = foundRects[i].serialNo;
		var targetResult = false;
		//找出指定結果的頁次
		if(foundIndex == targetIndex){
			targetResult = true;
			if(foundRects[i].width > 0){
				targetPage = foundRects[i].page;
			}
		}
		
		var highlightDiv = document.createElement("div");
		$(highlightDiv).addClass("searchResult");
		$(highlightDiv).css("position","absolute");
		var divLeft = foundRects[i].left + leftOffset;
		$(highlightDiv).css("left", divLeft + "px");
		$(highlightDiv).css("top",foundRects[i].top + "px");
		$(highlightDiv).css("width",foundRects[i].width + "px");
		$(highlightDiv).css("background-color","rgba(255, 255, 0, 0.28)");
		if(targetResult){
			$(highlightDiv).css("height", (foundRects[i].height - 2) + "px");
			$(highlightDiv).css("border-bottom","solid 3px #FF0000");
		}
		else{
			$(highlightDiv).css("height",foundRects[i].height + "px");	
		}
		
		document.body.appendChild(highlightDiv);
		reportToDevice("jsDebugInfo", foundRects[i].foundIndex + ":p." + foundRects[i].page + " (" + foundRects[i].left + ", " + foundRects[i].top + "), " + foundRects[i].width + "x" + foundRects[i].height);	
	}
	if(targetPage > 0){
		if(jumpPage){
			showPage(targetPage);
			reportToDevice("reportCurPage", targetPage);
		}
	}
}


function sortByPosition(a, b){
	if(a.page == b.page){
		if(a.top == b.top){
			return a.left - b.left;
		}
		else{
			return a.top - b.top;	
		}
	}
	else{
		return a.page - b.page;	
	}
}



function searchKeyword(keyword)
{
	foundRects = new Array();
    highlightAllOccurencesOfStringForElement(document.body, keyword.toLowerCase());
}


function highlightAllOccurencesOfStringForElement(element, keyword)
{
    if (element) {
        if (element.nodeType == 3) {
            var elementParent = element.parentNode;
            var checkingStartIndex = 0;
            var value = element.nodeValue;
            while(true){
                var idx = value.toLowerCase().indexOf(keyword, checkingStartIndex);
                if (idx == -1){
                    break;
                }
                
                var rangeObj = document.createRange();
                rangeObj.setStart(element, idx);
                rangeObj.setEnd(element, idx + keyword.length);
                appendRects(rangeObj, foundSerialNo++);
                checkingStartIndex = idx + keyword.length;
            }
        }
        else if (element.nodeType == 1) {
            if (element.style.display != "none" && element.nodeName.toLowerCase() != 'select') {
                for (var i=element.childNodes.length-1; i>=0; i--) {
                    highlightAllOccurencesOfStringForElement(element.childNodes[i],keyword);
                }
            }
        }
    }
}

function appendRects(element, serialNo){
	//var pageWidth = containerWidth + paddingLeft + paddingRight;
	var leftOffset = parseInt(document.body.scrollLeft);
	reportToDevice("jsDebugInfo", "leftOffset = " + leftOffset);
	var rects = element.getClientRects();
	for(var i = 0; i < rects.length; i++){
		rects[i].serialNo = serialNo;
		rects[i].page = Math.ceil((rects[i].left + leftOffset) / pageWidth);
		if(rects[i].page == 0){
			reportToDevice("jsDebugInfo", "page == 0, curPage = " + curPage + ", because rects[" + i + "].left = " + rects[i].left);
		}
		foundRects.push(rects[i]);
	}
}

function getPos(el)
{
    var rects = el.getClientRects();
    return {x : rects[0].left, y : rects[0].top};
}

/************************************
  /Search相關
  ***********************************/

if(document.addEventListener){
	document.addEventListener("DOMContentLoaded", DOMInitialize, false);
}

String.prototype.trim = function()
{
    return this.replace(/(^[\\s]*)|([\\s]*$)/g, "");
}


window.onload = initialize;
//window.onresize = resizeHandler;

//-->
